--[[
Drathals HUD2 (c) 2007 by Horacio Hoyos / Arcanefoam
Drathals HUD (c) 2006 by Caeryn Dryad
Drathals HUD (c) 2006 by Markus Inger / Drathal / Silberklinge / Silbersegen

Redistribution and use in source and binary forms, with or without 
modification, are permitted provided that the following conditions are 
met:

    * Redistributions of source code must retain the above copyright
       notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above 
       copyright notice, this list of conditions and the following 
       disclaimer in the documentation and/or other materials provided 
       with the distribution.
    * Neither the name of the Bartender3 Development Team nor the names of 
       its contributors may be used to endorse or promote products derived 
       from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE 
USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
]]

--ACE Version
local VERSION = tonumber(("$Revision 0000$"):match("%d+"))
--Addon Mix
DHUD2 = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0", "AceDB-2.0", "AceDebug-2.0", "FuBarPlugin-2.0")
local DHUD2, self = DHUD2, DHUD2
DHUD2.revision = "r" .. VERSION
DHUD2.versionstring = "0.2b |cffff8888r%d|r"
DHUD2.version = DHUD2.versionstring:format(VERSION)
DHUD2.date = ("$Date$"):match("%d%d%d%d%-%d%d%-%d%d")
local L = AceLibrary("AceLocale-2.2"):new("DHUD2")

local unpack = unpack
local pairs = pairs
local type = type 
local string_find = string.find
local string_format = string.format
local string_len = string.len
local string_sub = string.sub 
local string_gsub = string.gsub
local math_floor = math.floor
local UnitHealthMax = UnitHealthMax
local UnitHealth = UnitHealth
local UnitInParty = UnitInParty
local UnitIsEnemy = UnitIsEnemy
local UnitManaMax = UnitManaMax
local UnitMana = UnitMana
local UnitIsTapped = UnitIsTapped
local UnitIsTappedByPlayer = UnitIsTappedByPlayer
local UnitPowerType = UnitPowerType
local UnitClassification = UnitClassification
local UnitIsPlayer = UnitIsPlayer
local UnitPlayerControlled = UnitPlayerControlled
local UnitCanAttack = UnitCanAttack
local UnitIsPVP = UnitIsPVP
local UnitCanAttack = UnitCanAttack
local UnitFactionGroup = UnitFactionGroup
local UnitReaction = UnitReaction
local UnitIsPVPFreeForAll = UnitIsPVPFreeForAll
local GetPlayerBuff = GetPlayerBuff
local GetPlayerBuffTimeLeft = GetPlayerBuffTimeLeft
local UnitBuff = UnitBuff
local UnitDebuff = UnitDebuff
local GetRaidTargetIndex = GetRaidTargetIndex
local GetDifficultyColor = GetDifficultyColor
local UnitCreatureType = UnitCreatureType
local GetPlayerBuffTimeLeft = GetPlayerBuffTimeLeft
local UnitClass = UnitClass
local UnitIsDeadOrGhost = UnitIsDeadOrGhost
local UnitPlayerOrPetInParty = UnitPlayerOrPetInParty 
local GetPetHappiness = GetPetHappiness
local UnitIsUnit = UnitIsUnit

--Options
local defaultfont = "Fonts/FRIZQT__.TTF"
local defaultfont_num = "Interface\\AddOns\\DHUD\\Layouts\\Number.TTF"
local options
do
    --Gral
	local function setgral(field, value)
		self.db.profile[field] = value
        DHUD2_mainFrame:SetScale(self.db.profile.scale)
        self:updatePlayerAuras()
	end
	local function getgral(field)
		return self.db.profile[field]
	end
    --Show
    local function setshow(field, value)
        local p = self.db.profile
		p.show[field] = value
        self:blizzFrames(p.show.blizplayer, p.show.bliztarget, p.show.blizpet, p.show.blizcasting)		
	end
	local function getshow(field)
		return self.db.profile.show[field]
	end
    --Alphas
    local function setalpha(field, value)
        self.db.profile.alphas[field] = value
        self:updateAlpha()
    end
    local function getalpha(field)
        return self.db.profile.alphas[field]
    end
    --Fonts
    local maxfont = 30
    local minfont = 6
    local function getfont(field)
        return self.db.profile.fontsize[field]
    end
    local function setfont(field, value)
        self.db.profile.fontsize[field] = value
        self:setFonts()
    end
    --Outlines
    local function setout(field, value)
        self.db.profile.outlines[field] = value
        self:setFonts()
    end
    local function getout(field)
        return self.db.profile.outlines[field]
    end
    --Offsets
    local function getoffset(field)
        return self.db.profile.offsets[field]
    end
    local function setoffset(field, value)
        self.db.profile.offsets[field] = value
    end
    --Styles
    local styleValueVal = {"Full", "Simple", "Small", "Percent", "Minimal"}
    local styleValueDesc = {["Full"] = "<value>/<maxval><percent>", ["Simple"] = "<value>/<maxval>", ["Small"] = "<value><percent>", ["Percent"] = "<percent>", ["Minimal"] = "<value>"}
    local styleNamesVal = {"Full", "Simple", "Small", "Minimal"}
    local styleNamesDesc = {["Full"] = "<level><elite> <name> [ <class><pet><npc> ]", ["Simple"] = "<level><elite> <name>", ["Small"] = "<name> [ <class><pet><npc> ]", ["Minimal"] = "<level> <name>"}
    local borderVal = {"OUTLINE", "THICKOUTLINE", "OUTLINE, MONOCHROME", "THICKOUTLINE, MONOCHROME", ""}
    local borderDesc = {["OUTLINE"] = "Normal", ["THICKOUTLINE"] = "Thick", ["OUTLINE, MONOCHROME"] = "Monochrome", ["THICKOUTLINE, MONOCHROME"] = "Thick Monochrome", [""] = "None"} 
    local function getstyle(field)
        return self.db.profile.styles[field]
    end
    local function setstyle(field, value)
        self.db.profile.styles[field] = value
    end
    --Colors
	local function setmaxcolor(field, ...)
		self.db.profile.colors[field].color0 = {...}
	end
	local function getmaxcolor(field)
		return unpack(self.db.profile.colors[field].color0)
	end    
    local function setmedcolor(field, ...)
		self.db.profile.colors[field].color1 = {...}
	end	
	local function getmedcolor(field)
		return unpack(self.db.profile.colors[field].color1)
	end
    local function setmincolor(field, ...)
		self.db.profile.colors[field].color2 = {...}
	end
		
	local function getmincolor(field)
		return unpack(self.db.profile.colors[field].color2)
	end
    --Options table
	options = {
		type = 'group',
		args = {
			gral = {
                type = 'group',
                name = L["General"],
                desc = L["General Settings"],
                order = 100,
                args = {
                    scale = {
                        type = 'range',
						name = L["Scale"],
						desc = L["Set DHUD2's scale"],
						min = 0.2,
						max = 2,
						step = 0.1,
						get = getgral,
						set = setgral,
						order = 101,
                        passValue = "scale",
                        },
                    revcasting = {
                        type = 'toggle',
                        name = L["Reverse Castbar"],
                        desc = L["Show casting bar from full to empty"],
                        get = getgral,
						set = setgral,
                        map = { [false] = "Disabled", [true] = "Enabled" },
                        order = 102,
                        passValue = "revcastig",
                        },
                    swaptargetAuras = {
                        type = 'toggle',
                        name = L["Swap Target Auras"],
                        desc = L["Swap target auras position"],
                        get = getgral,
						set = setgral,
                        map = { [false] = "Disabled", [true] = "Enabled" },
                        order = 103,
                        passValue = "swaptargetAuras",
                        },
                    playerbufftimefilter = {
                        type = 'range',
						name = L["Player Buff Timer Filter"],
						desc = L["Define the time filter to show player buffs (seconds)"],
						min = 0,
						max = 3600,
						step = 1,
						get = getgral,
						set = setgral,
						order = 104,
                        passValue = "playerbufftimefilter",
                        }
                    },
                },
            show = {
                type = 'group',
                name = L["Display"],
                desc = L["Choose what to display"],
                order = 200,
                args = {
                    auratips = {
                        type ='toggle',
                        name = L["Aura Tips"],
                        desc = L["Show aura tips when moused over"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 201,
                        passValue = "auratips",
                        },
                    barborders = {
                        type ='toggle',
                        name = L["Bar Borders"],
                        desc = L["Show bar borders"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 202,
                        passValue = "barborders",
                        },
                    blizcasting = {
                        type ='toggle',
                        name = L["Blizzard Casting Bar"],
                        desc = L["Show Blizzard casting bar"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 203,
                        passValue = "blizcasting",
                        },
                    blizpet = {
                        type ='toggle',
                        name = L["Blizzard Pet Bar"],
                        desc = L["Show Blizzard's pet frame"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 204,
                        passValue = "blizpet",
                        },
                    blizplayer = {
                        type ='toggle',
                        name = L["Blizzard Player Frame"],
                        desc = L["Show Blizzard's player frame"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 205,
                        passValue = "blizplayer"
                        },
                    bliztarget = {
                        type ='toggle',
                        name = L["Blizzard Target Frame"],
                        desc = L["Show Blizzard's target frame"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 206,
                        passValue = "bliztarget",
                        },
                    casting = {
                        type ='toggle',
                        name = L["Casting Bar"],
                        desc = L["Show DHUD2 casting bar"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 207,
                        passValue = "casting",
                        },
                    combaticon = {
                        type ='toggle',
                        name = L["Combat Icon"],
                        desc = L["Show combat icon"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 208,
                        passValue = "combaticon",
                        },
                    druidbar = {
                        type ='toggle',
                        name = L["Druid Bar"],
                        desc = L["Show Druid's mana in pet's power bar when shape-shifted (requires SmartyCat)"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 209,
                        passValue = "druidbar",
                        },
                    eliteicon = {
                        type ='toggle',
                        name = L["Elite Icon"],
                        desc = L["Show elite icon for targets"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 210,
                        passValue = "eliteicon",
                        },                        
                    npc = {
                        type ='toggle',
                        name = L["Target NPCs"],
                        desc = L["Show target bars when targeting NPCs"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 211,
                        passValue = "npc",
                        },
                    pet = {
                        type ='toggle',
                        name = L["Player Pet"],
                        desc = L["Show player's pet bars"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 212,
                        passValue = "pet",
                        },
                    peticon = {
                        type ='toggle',
                        name = L["Pet Happiness Icon"],
                        desc = L["Show pet happiness icon"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 213,
                        passValue = "peticon",
                        },
                    playerbuffs = {
                        type ='toggle',
                        name = L["Player Buffs"],
                        desc = L["Show player buffs (filtered by Buff Timer Filter)"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 214,
                        passValue = "playerbuffs",
                        },
                    playerpvpicon = {
                        type ='toggle',
                        name = L["Player PvP Icon"],
                        desc = L["Show player's PvP icon"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 215,
                        passValue = "playerpvpicon",
                        },
                    resticon = {
                        type ='toggle',
                        name = L["Player Rest Icon"],
                        desc = L["Show player's rest icon"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 216,
                        passValue = "resticon",
                        },
                    target = {
                        type ='toggle',
                        name = L["Target Bars"],
                        desc = L["Show target bars when targeting"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 217,
                        passValue = "target",
                        },
                    targetauras = {
                        type ='toggle',
                        name = L["Target Auras"],
                        desc = L["Show target auras"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 218,
                        passValue = "targetauras",
                        },
                    targetpvpicon = {
                        type ='toggle',
                        name = L["Target PvP Icon"],
                        desc = L["Show targets PvP icon"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 219,
                        passValue = "targetpvpicon",
                        },
                    targetTarget = {
                        type ='toggle',
                        name = L["Target of Target"],
                        desc = L["Show target's target text"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 220,
                        passValue = "targetTarget"
                        },
                    },
                },
            alphas = {
                type = 'group',
                name = L["Alpha"],
                desc = L["Set HUD situation alpha"],
                order = 300,
                args = {
                    combat = {
                        type = 'range',
						name = L["Combat"],
						desc = L["Set HUD in combat alpha"],
						min = 0,
						max = 1,
						step = 0.05,
                        get = getalpha,
                        set = setalpha,
                        order = 301,
                        passValue = "combat",
                        },
                    ooc = {
                        type = 'range',
						name = L["Off Combat"],
						desc = L["Set HUD in out of combat alpha"],
						min = 0,
						max = 1,
						step = 0.05,
                        get = getalpha,
                        set = setalpha,
                        order = 302,
                        passValue = "ooc",
                        },
                    select = {
                        type = 'range',
						name = L["Selection"],
						desc = L["Set HUD when selecting alpha"],
						min = 0,
						max = 1,
						step = 0.05,
                        get = getalpha,
                        set = setalpha,
                        order = 303,
                        passValue = "select",
                        },
                    regen = {
                        type = 'range',
						name = L["Regeneration"],
						desc = L["Set HUD alpha when regenerating"],
						min = 0,
						max = 1,
						step = 0.05,
                        get = getalpha,
                        set = setalpha,
                        order = 304,
                        passValue = "regen",
                        },
                    casting = {
                        type = 'range',
						name = L["Casting"],
						desc = L["Set HUD alpha when casting"],
						min = 0,
						max = 1,
						step = 0.05,
                        get = getalpha,
                        set = setalpha,
                        order = 305,
                        passValue = "casting",
                        },
                    dead = {
                        type = 'range',
						name = L["Death"],
						desc = L["Set HUD alpha when dead"],
						min = 0,
						max = 1,
						step = 0.05,
                        get = getalpha,
                        set = setalpha,
                        order = 306,
                        passValue = "dead",
                        },
                    },
                },
            outlines = {
                type = 'group',
                name = L["Outlines"],
                desc = L["Show Outlines"],
                order = 400,
                args = {
                    playerBuff = {
                        type ='text',
                        name = L["Player Buffs"],
                        desc = L["Show player's buff outline"],
                        get = getout,
						set = setout,
                        validate = borderVal,
                        validateDesc = borderDesc,
                        order = 401,
                        passValue = "playerBuff"
                        },
                    castDelay = {
                        type ='text',
                        name = L["Cast Delay Text"],
                        desc = L["Show cast delay text's outline"],
                        get = getout,
						set = setout,
                        validate = borderVal,
                        validateDesc = borderDesc,
                        order = 402,
                        passValue = "castDelay"
                        },
                    castTime = {
                        type ='text',
                        name = L["Cast Time Text"],
                        desc = L["Show cast time text's outline"],
                        get = getout,
						set = setout,
                        validate = borderVal,
                        validateDesc = borderDesc,
                        order = 403,
                        passValue = "castTime"
                        },
                    playerHelath = {
                        type ='text',
                        name = L["Player Health Text"],
                        desc = L["Show player health text outline"],
                        get = getout,
						set = setout,
                        validate = borderVal,
                        validateDesc = borderDesc,
                        order = 404,
                        passValue = "playerHelath"
                        },
                    playerPower = {
                        type ='text',
                        name = L["Player Power Text"],
                        desc = L["Show player power (mana/rage/energy) text's outline"],
                        get = getout,
						set = setout,
                        validate = borderVal,
                        validateDesc = borderDesc,
                        order = 405,
                        passValue = "playerPower"
                        },
                    targetHealth = {
                        type ='text',
                        name = L["Target Health Text"],
                        desc = L["Show target health text's outline"],
                        get = getout,
						set = setout,
                        validate = borderVal,
                        validateDesc = borderDesc,
                        order = 406,
                        passValue = "targetHealth"
                        },
                    targetPower = {
                        type ='text',
                        name = L["Target Power Text"],
                        desc = L["Show target power text's outline"],
                        get = getout,
						set = setout,
                        validate = borderVal,
                        validateDesc = borderDesc,
                        order = 407,
                        passValue = "targetPower"
                        },
                    petHealth = {
                        type ='text',
                        name = L["Pet Health Text"],
                        desc = L["Show pet health text's outline"],
                        get = getout,
						set = setout,
                        validate = borderVal,
                        validateDesc = borderDesc,
                        order = 408,
                        passValue = "petHealth"
                        },
                    petPower = {
                        type ='text',
                        name = L["Pet Power Text"],
                        desc = L["Show pet power text's outline"],
                        get = getout,
						set = setout,
                        validate = borderVal,
                        validateDesc = borderDesc,
                        order = 409,
                        passValue = "petPower"
                        },
                    target = {
                        type ='text',
                        name = L["Target Text"],
                        desc = L["Show target text's outline"],
                        get = getout,
						set = setout,
                        validate = borderVal,
                        validateDesc = borderDesc,
                        order = 410,
                        passValue = "target"
                        },
                    targetTarget = {
                        type ='text',
                        name = L["Target Text"],
                        desc = L["Show target text's outline"],
                        get = getout,
						set = setout,
                        validate = borderVal,
                        validateDesc = borderDesc,
                        order = 411,
                        passValue = "targetTarget"
                        },
                    },
                },
            fontsize = {
            type = 'group',
            name = L["Font Sizes"],
            desc = L["Choose font size for the different texts"],
            order = 500,
            args = {
                playerBuff = {
                    type = 'range',
                    name = L["Player Buff"],
                    desc = L["Set player buff text font size"],
                    min = minfont,
                    max = maxfont,
                    step = 1,
                    get = getfont,
                    set = setfont,
                    order = 501,
                    passValue = "playerBuff",
                    },
                castDelay = {
                    type = 'range',
                    name = L["Cast Delay"],
                    desc = L["Set cast delay text font size"],
                    min = minfont,
                    max = maxfont,
                    step = 1,
                    get = getfont,
                    set = setfont,
                    order = 502,
                    passValue = "castDelay",
                    },
                castTime = {
                    type = 'range',
                    name = L["Cast Time"],
                    desc = L["Set cast time text font size"],
                    min = minfont,
                    max = maxfont,
                    step = 1,
                    get = getfont,
                    set = setfont,
                    order = 503,
                    passValue = "castTime",
                    },
                player = {
                    type = 'range',
                    name = L["Player"],
                    desc = L["Set player health and power (mana/rage/energy) text font size"],
                    min = minfont,
                    max = maxfont,
                    step = 1,
                    get = getfont,
                    set = setfont,
                    order = 503,
                    passValue = "player",
                    },
                target = {
                    type = 'range',
                    name = L["Target"],
                    desc = L["Set target health and power (mana/rage/energy) text font size"],
                    min = minfont,
                    max = maxfont,
                    step = 1,
                    get = getfont,
                    set = setfont,
                    order = 504,
                    passValue = "target",
                    },
                pet = {
                    type = 'range',
                    name = L["Pet"],
                    desc = L["Set pet health and power (mana/rage/energy) text font size"],
                    min = minfont,
                    max = maxfont,
                    step = 1,
                    get = getfont,
                    set = setfont,
                    order = 505,
                    passValue = "pet",
                    },
                targetName = {
                    type = 'range',
                    name = L["Target Name"],
                    desc = L["Set target's name text font size"],
                    min = minfont,
                    max = maxfont,
                    step = 1,
                    get = getfont,
                    set = setfont,
                    order = 505,
                    passValue = "targetName",
                    },	
                targetTargetName = {
                    type = 'range',
                    name = L["Target Target Name"],
                    desc = L["Set target target's name text font size"],
                    min = minfont,
                    max = maxfont,
                    step = 1,
                    get = getfont,
                    set = setfont,
                    order = 505,
                    passValue = "targetTargetName",
                    },
                },
            },
            styles = {
                type = 'group',
                name = L["Text Style"],
                desc = L["Choose text style for names and health/power"],
                order = 600,
                args = {
                    playerHealth = {
                        type = 'text',
                        name = L["Player Health"],
                        desc = L["Choose text style for player's health"],
                        get = getstyle,
                        set = setstyle,
                        validate = styleValueVal,
                        validateDesc = styleValueDesc,
                        order = 601,
                        passValue = "playerHealth",
                        },
                    playerPower = {
                        type = 'text',
                        name = L["Player Power"],
                        desc = L["Choose text style for player's power (mana/rage/energy)"],
                        get = getstyle,
                        set = setstyle,
                        validate = styleValueVal,
                        validateDesc = styleValueDesc,
                        order = 602,
                        passValue = "playerPower",
                        },
                    petHealth = {
                        type = 'text',
                        name = L["Pet Health"],
                        desc = L["Choose text style for pet's health"],
                        get = getstyle,
                        set = setstyle,
                        validate = styleValueVal,
                        validateDesc = styleValueDesc,
                        order = 603,
                        passValue = "petHealth",
                        },
                    petPower = {
                        type = 'text',
                        name = L["Pet Power"],
                        desc = L["Choose text style for pet's power"],
                        get = getstyle,
                        set = setstyle,
                        validate = styleValueVal,
                        validateDesc = styleValueDesc,
                        order = 604,
                        passValue = "petPower",
                        },
                    targetHealth = {
                        type = 'text',
                        name = L["Target Health"],
                        desc = L["Choose text style for target's health"],
                        get = getstyle,
                        set = setstyle,
                        validate = styleValueVal,
                        validateDesc = styleValueDesc,
                        order = 605,
                        passValue = "targetHealth",
                        },
                    targetPower = {
                        type = 'text',
                        name = L["Target Power"],
                        desc = L["Choose text style for target's power"],
                        get = getstyle,
                        set = setstyle,
                        validate = styleValueVal,
                        validateDesc = styleValueDesc,
                        order = 606,
                        passValue = "targetHealth",
                        },
                    target = {
                        type = 'text',
                        name = L["Target Text"],
                        desc = L["Choose text style for target's text"],
                        get = getstyle,
                        set = setstyle,
                        validate = styleNamesVal,
                        validateDesc = styleNamesDesc,
                        order = 607,
                        passValue = "target",
                        },
                    targetTarget = {
                        type = 'text',
                        name = L["TargetTarget Text"],
                        desc = L["Choose text style for targetTarget's text"],
                        get = getstyle,
                        set = setstyle,
                        validate = styleNamesVal,
                        validateDesc = styleNamesDesc,
                        order = 608,
                        passValue = "targetTarget",
                        },
                    },
            },
            colors = {
                type = 'group',
                name = L["Colors"],
                desc = L["Change the bar colors. Choose max, medium and low colors and DHUD2 mixes them as the value of the bar changes"],
                order = 7000,
                args = {
                    playerAura = {
                        type = 'group',
                        name = L["Player Aura"],
                        desc = L["Player's aura color"],
                        order = 7010,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 7011,
                                passValue = "playerAura",
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 7012,
                                passValue = "playerAura",
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 7013,
                                passValue = "playerAura",
                                },
                            },
                        },          
                    playerHealth = {
                        type = 'group',
                        name = L["Player Health"],
                        desc = L["Player's health color"],
                        order = 7020,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 7021,
                                passValue = "playerHealth",
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 7022,
                                passValue = "playerHealth",
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 7023,
                                passValue = "playerHealth",
                                },
                            },
                        },
                    playerMana = {
                        type = 'group',
                        name = L["Player Mana"],
                        desc = L["Player's mana color"],
                        order = 7030,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 7031,
                                passValue = "playerMana",
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 7032,
                                passValue = "playerMana",
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 7033,
                                passValue = "playerMana",
                                },
                            },
                        },
                    playerRage = {
                        type = 'group',
                        name = L["Player Rage"],
                        desc = L["Player's rage color"],
                        order = 7040,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 7041,
                                passValue = "playerRage",
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 7042,
                                passValue = "playerRage",
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 7043,
                                passValue = "playerRage",
                                },
                            },
                        },
                    playerEnergy = { 
                        type = 'group',
                        name = L["Player Energy"],
                        desc = L["Player's energy color"],
                        order = 7050,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 7051,
                                passValue = "playerEnergy",
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 7052,
                                passValue = "playerEnergy",
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 7053,
                                passValue = "playerEnergy",
                                },
                            },
                        },
                    targetHealth = {
                        type = 'group',
                        name = L["Target Health"],
                        desc = L["Target's health color"],
                        order = 7060,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 7061,
                                passValue = "targetHealth",
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 7062,
                                passValue = "targetHealth",
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 7063,
                                passValue = "targetHealth",
                                },
                            },
                        },
                    targetMana = {
                        type = 'group',
                        name = L["Target Mana"],
                        desc = L["Target's mana color"],
                        order = 7070,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 7071,
                                passValue = "targetMana",
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 7072,
                                passValue = "targetMana",
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 7073,
                                passValue = "targetMana",
                                },
                            },
                        },
                    targetRage = { 
                        type = 'group',
                        name = L["Target Rage"],
                        desc = L["Target's rage color"],
                        order = 7080,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 7081,
                                passValue = "targetRage",
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 7082,
                                passValue = "targetRage",
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 7083,
                                passValue = "targetRage",
                                },
                            },
                        },
                    targetEnergy = { 
                        type = 'group',
                        name = L["Target Energy"],
                        desc = L["Target's energy color"],
                        order = 7090,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 7091,
                                passValue = "targetEnergy",
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 7092,
                                passValue = "targetEnergy",
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 7093,
                                passValue = "targetEnergy",
                                },
                            },
                        },
                    targetFocus = {
                        type = 'group',
                        name = L["Target Focus"],
                        desc = L["Target's focus color"],
                        order = 7100,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 7101,
                                passValue = "targetFocus",
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 7102,
                                passValue = "targetFocus",
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 7103,
                                passValue = "targetFocus",
                                },
                            },
                        },
                    petHealth = {
                        type = 'group',
                        name = L["Pet Health"],
                        desc = L["Pet's health color"],
                        order = 7110,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 7111,
                                passValue = "petHealth",
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 7112,
                                passValue = "petHealth",
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 7113,
                                passValue = "petHealth",
                                },
                            },
                        },
                    petMana = { 
                        type = 'group',
                        name = L["Pet Mana"],
                        desc = L["Pet's mana color"],
                        order = 7120,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 7121,
                                passValue = "petMana",
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 7122,
                                passValue = "petMana",
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 7123,
                                passValue = "petMana",
                                },
                            },
                        },
                    petFocus = {
                        type = 'group',
                        name = L["Pet Focus"],
                        desc = L["Pet's focus color"],
                        order = 7130,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 7131,
                                passValue = "petFocus",
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 7132,
                                passValue = "petFocus",
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 7133,
                                passValue = "petFocus",
                                },
                            },
                        },
                    casting = { 
                        type = 'group',
                        name = L["Casting Bar"],
                        desc = L["Cast bar color"],
                        order = 7140,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 7141,
                                passValue = "casting",
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 7142,
                                passValue = "casting",
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 7143,
                                passValue = "casting",
                                },
                            },
                        },
                    channelBar = { 
                        type = 'group',
                        name = L["Channel Bar"],
                        desc = L["Channel bar color"],
                        order = 7150,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 7151,
                                passValue = "channelBar",
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 7152,
                                passValue = "channelBar",
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 7153,
                                passValue = "channelBar",
                                },
                            },
                        },
                    tapped = { 
                        type = 'group',
                        name = L["Tapped"],
                        desc = L["Tapped mob color"],
                        order = 7160,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 7161,
                                passValue = "tapped",
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 7162,
                                passValue = "tapped",
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 7163,
                                passValue = "tapped",
                                },
                            },
                        },
                },
            },
        }
    }
	
end
DHUD2.options = options

--Profile Defaults
local styles = {
    values = {
        ["Full"] = "<value>/<maxval><percent>",
        ["Simple"] = "<value>/<maxval>",
        ["Small"] = "<value><percent>",
        ["Percent"] = "<percent>",
        ["Minimal"] = "<value>",
        },
    names = {
        ["Full"] = "<level><elite> <name> [ <class><pet><npc> ]",
        ["Simple"] = "<level><elite> <name>",
        ["Small"] = "<name> [ <class><pet><npc> ]",
        ["Minimal"] = "<level> <name>",
    },
}
local classColors = {
    ["HUNTER"] = "ABD473", 
    ["WARLOCK"] = "9482C9",
    ["PRIEST"] = "FFFFFF",
    ["PALADIN"] = "F58CBA",
    ["MAGE"] = "69CCF0",
    ["ROGUE"] = "FFF569",
    ["DRUID"] = "FF7D0A",
    ["SHAMAN"] = "00DBBA",
    ["WARRIOR"] = "C79C6E",
}
local targetBorder = ""
local petBorder = ""
local isAlive = false
local isDead = false
local regen = false
local isCasting = false
local inCombat = false
local isDruid = false
local hasPet = false
local playerNeedH, playerNeedP, targetNeedH, targetNeedP, petNeedH, petNeedP
local defaultfont = "Fonts/FRIZQT__.TTF"
local defaultfont_num = "Interface\\AddOns\\DHUD\\layout\\Number.TTF"
--[[
DHUD2.petBorder = petBorder
DHUD2.playerNeedH = playerNeedH
DHUD2.playerNeedP = playerNeedP 
DHUD2.targetNeedH = targetNeedH
DHUD2.targetNeedP = targetNeedP
DHUD2.petNeedH = petNeedH
DHUD2.petNeedP = petNeedP
]]--

DHUD2:RegisterDB("DHUD2DB", "DHUD2DBPC")
local auraUpdateInterval = 1
do
    local layout = "Standard"
    local colors = {
        playerAura = {
            color0 = { 1, 1, 1 },
            color1 = {255/255, 125/255, 125/255 },
            color2 = { 255/255, 65/255, 0 }
        },
        playerHealth = {
            color0 = { 0, 1, 0 },
            color1 = { 1, 1, 0 },
            color2 = { 1, 0, 0 }      
        },
        playerMana = {
            color0 = { 0, 1, 1 },
            color1 = { 0, 0, 1 },
            color2 = { 1, 0, 1 }
        },
        playerRage = {
            color0 = { 1, 0, 0 },
            color1 = { 1, 0, 0 },
            color2 = { 1, 0, 0 }
        },
        playerEnergy = { 
            color0 = { 1, 1, 0 },
            color1 = { 1, 1, 0 },
            color2 = { 1, 1, 0 }
        },
        targetHealth = {
            color0 = { 0, 0.67, 0 },
            color1 = { 0.67, 0.67, 0 },
            color2 = { 0.67, 0, 0 }
        },
        targetMana = {
            color0 = { 0, 0.67, 0.67 },
            color1 = { 0, 0, 0.67 },
            color2 = { 1, 0, 0.67 }
        },
        targetRage = { 
            color0 = { 0.67, 0, 0 },
            color1 = { 0.67, 0, 0 },
            color2 = { 0.67, 0, 0 }
        },
        targetEnergy = { 
            color0 = { 0.67, 0.67, 0 },
            color1 = { 0.67, 0.67, 0 },
            color2 = { 0.67, 0.67, 0 }
        },
        targetFocus = {
            color0 = { 0.67, 0.27, 0 },
            color1 = { 0.67, 0.27, 0 },
            color2 = { 0.67, 0.27, 0 }
        },
        petHealth = {
            color0 = { 0, 1, 0 },
            color1 = { 1, 1, 0 },
            color2 = { 1, 0, 0 }
        },
        petMana = { 
            color0 = { 0, 1, 1 },
            color1 = { 0, 0, 1 },
            color2 = { 1, 0, 1 }
        },
        petFocus = {
            color0 = { 0.67, 0.27, 0 },
            color1 = { 0.67, 0.27, 0 },
            color2 = { 0.67, 0.27, 0 }
        },
        casting = { 
            color0 = { 0, 1, 0 },
            color1 = { 0.53, 1, 0 },
            color2 = { 1, 1, 0 }
        },
        channelBar = { 
            color0 = { 0.88, 0.88, 1 },
            color1 = { 0.75, 0.75, 0 },
            color2 = { 0.63, 0.63, 0 }
        },
        tapped = {
            color0 = { 0.8, 0.8, 0.8 },
            color1 = { 0.73, 0.73, 0.73 },
            color2 = { 0.67, 0.67, 0.67 }
        },
    }
    DHUD2:RegisterDefaults("profile", {
        layout = layout,
        colors = colors,
        scale = 1,
        revcasting = true,
        swaptargetAuras = false,
        playerbufftimefilter = 600,
        show = {
            auratips = true,
            barborders = true,
            blizcasting = false,
            blizpet = false,
            blizplayer = false,
            bliztarget = false,
            casting = true,
            combaticon = true,
            druidbar = true,
            eliteicon = true,
            npc = true,
            pet = true,
            peticon = true,
            playerbuffs = true,
            playerpvpicon = true,
            resticon = true,
            target = true,
            targetauras = true,
            targetpvpicon = true,
            targetTarget = true,
        },
        alphas = {
            combat = 1,
            ooc = 0,
            select = 0.6,
            regen = 0.4,
            casting = 0.8,
            dead = 0,
        },
        outlines = {
            playerBuff = "OUTLINE",
            castDelay = "OUTLINE",
            castTime = "OUTLINE",
            playerHealth = "OUTLINE",
            playerPower = "OUTLINE",
            targetHealth = "OUTLINE",
            targetPower = "OUTLINE",
            petHealth = "OUTLINE",
            petPower = "OUTLINE",
            target = "OUTLINE",
            targetTarget = "OUTLINE",
        },
        fontsize = {
            playerBuff = 12,
            castDelay = 10,
            castTime = 10,
            player = 10,
            target = 10,
            pet = 9,
            targetName = 12,	
            targetTargetName = 10,
        },
        offsets = {
            xoffset = 0,
            yoffset = 0,
            hudspacing = 0,
            targettextx = 0,
            targettexty = 0,
            targetTargetx = 0,
            targetTargety = 0,
            playerhptextx = 0,
            playerhptexty = 0,
            playerPowertextx = 0,
            playerPowertexty = 0,
            targethptextx = 0,
            targethptexty = 0,
            targetPowertextx = 0,
            targetPowertexty = 0,
            pethptextx = 0,
            pethptexty = 0,
            petPowertextx = 0,
            petPowertexty = 0,      
        },
        styles = {
            playerHealth = "Full",
            playerPower = "Full",
            petHealth = "Small",
            petPower = "Small",
            targetHealth = "Small",
            targetPower = "Small",
            target = "Full",
            targetTarget = "Full",
        },  
    })
    --FuBar
    DHUD2.name                   = "DHUD2"
    DHUD2.hasIcon                = true
    DHUD2.defaultMinimapPosition = 240
    DHUD2.cannotDetachTooltip    = true
    DHUD2.independentProfile     = true
    DHUD2.defaultPosition        = "RIGHT"
    DHUD2.hideWithoutStandby     = true
    DHUD2.OnMenuRequest          = options
end

--Local functions
local colorize, rgb2hex, formatTime, checkElite, unitIsNPC, unitIsPet, getReactionColor, getTypUnit
do
    function colorize(typunit, percent)
        local colorTable = self.db.profile.colors
        if not colorTable[typunit] then return 0,0,0; end
        local r, g, b, diff
        local threshold1, threshold2  = 0.6, 0.3
        local r0, g0, b0 = unpack(colorTable[typunit].color0)
        local r1, g1, b1 = unpack(colorTable[typunit].color1)
        local r2, g2, b2 = unpack(colorTable[typunit].color2)
            
        if ( percent <= threshold2 ) then
            r, g, b = r2, g2, b2
        elseif ( percent <= threshold1) then
            diff = 1 - (percent - threshold2) / (threshold1 - threshold2);
            r = r1 - (r1 - r2) * diff;        
            g = g1 - (g1 - g2) * diff;        
            b = b1 - (b1 - b2) * diff;    
        elseif ( percent < 1) then        
            diff = 1 - (percent - threshold1) / (1 - threshold1);        
            r = r0 - (r0 - r1) * diff;        
            g = g0 - (g0 - g1) * diff;        
            b = b0 - (b0 - b1) * diff;    
        else       
            r, g, b = r0, g0, b0
        end
        if (r < 0) then r = 0; end    
        if (r > 1) then r = 1; end    
        if (g < 0) then g = 0; end    
        if (g > 1) then g = 1; end    
        if (b < 0) then b = 0; end    
        if (b > 1) then b = 1; end
        hex = rgb2hex(r, g, b)
        return r, g, b, hex
    end

    function rgb2hex(r, g, b)
        local hexr, hexg, hexb
        hexr = string_format("%x", r * 255)
        hexr = string_len(hexr) == 1 and "0"..hexr or hexr
        hexg = string_format("%x", g * 255)
        hexg = string_len(hexg) == 1 and "0"..hexg or hexg
        hexb = string_format("%x", b * 255)
        hexb = string_len(hexb) == 1 and "0"..hexb or hexb
        return hexr..hexg..hexb
    end
    
    function formatTime(secs)
    	if secs >= 86400 then
    		return format('%dd', math_floor(secs/86400 + 0.5));
    	elseif secs >= 3600 then
    		return format('%dh', math_floor(secs/3600 + 0.5));
    	elseif secs >= 60 then
    		return format('%dm', math_floor(secs/60 + 0.5));
        else
            --return format('%ds', floor(secs + 0.5));
            return (math_floor(secs + 0.5));
        end
    end
    
    local eliteValues = {
        ["worldboss"] = {"targetElite", "++"},
        ["elite"] = {"targetElite", "+"},
        ["rareelite"] = {"targetRare", "r+"},
        ["rare"] = {"targetRare", "r"},
        ["normal"] = {false, ""},
        }
    function checkElite(unit)
        local el = UnitClassification(unit)
        return eliteValues[el][1], eliteValues[el][2]
    end
    
    function unitIsNPC(unit)
        return not (UnitIsPlayer(unit) or UnitPlayerControlled(unit) or UnitCanAttack("player", unit))
    end
   
    function unitIsPet(unit)
        return not unitIsNPC(unit) and not UnitIsPlayer(unit) and UnitPlayerControlled(unit)
    end
    
    local reacColors = {
        "ff0000",
        "ffff00",
        "55ff55",
        "6d6dff",
        "008800",
        "cccccc",
        }
    function getReactionColor(unit)
    	local color
        if (UnitIsTapped(unit) and (not UnitIsTappedByPlayer(unit))) then
    		color = 6
    	elseif (UnitIsPlayer(unit)) then
    		if (UnitIsPVP(unit)) then
                color = UnitCanAttack("player", unit) and 1 or 5
    		else
    			if (UnitCanAttack("player", unit) or UnitFactionGroup(unit) ~= UnitFactionGroup("player")) then
    				color = 2
    			else
    				color = 4
    			end
    		end
    	else
    		local reaction = UnitReaction(unit, "player");
    		if (reaction) then
    			if (reaction < 4) then
    				color = 1
    			elseif (reaction == 4) then
    				color = 2
    			else
    				color = 3
    			end
    		end
    	end
    	return reacColors[color];
    end
    
    local powertypes = {"Mana","Rage","Focus","Energy","Happiness"}
    function getTypUnit(unit, typ)
        if unit == "target" then
            if (UnitIsTapped("target") and (not UnitIsTappedByPlayer("target"))) then               return "tapped"
            end
        end
        if typ == "Power" then
            if UnitPowerType(unit) then
                typ = powertypes[UnitPowerType(unit) + 1]
            end
        end
        return unit..typ
    end
    
end

--Global functions
local getHealth, getPower, setBarHeight, setBarColor
do
    function getHealth(unit)
        local maxval, curval, fracval, need, found
        maxval = UnitHealthMax(unit)
        curval = UnitHealth(unit)
        if unit == "player" or unit == "pet" or UnitIsUnit(unit, "pet") then            
            fracval = curval / maxval
        else
            if UnitInParty(unit) then
                fracval = curval / maxval
            elseif UnitIsEnemy("player", unit) then
                if MobHealth3 then
                    curval, maxval, found = MobHealth3:GetUnitHealth(unit, curval, 
                    maxval)
                end
                if found then
                    fracval = curval / maxval
                else
                    fracval = curval / 100
                end
            else
                fracval = curval / 100
            end
        end
        if fracval ~= 1 then 
            need = true
        end
        return maxval, curval, fracval, need
    end
    
    function getPower(unit, powerType)
        local maxval, curval, fracval, need
        maxval = UnitManaMax(unit)
        curval = UnitMana(unit)
        if maxval ~= 0 then
            fracval = curval / maxval
            if powerType == 1 then
                if fracval ~= 0 then 
                    need = true
                end
            else
                if fracval ~= 1 then 
                    need = true
                end
            end
        else
            fracval = 0
            need = false
        end
        return maxval, curval, fracval, need
    end
    
    function setBarHeight(bar, percent)
        -- Hide when Bar empty 
        if math_floor(percent * 100) == 0 then
            getglobal("DHUD2_"..bar.."_Texture"):Hide()
            return
        end
        local texture = getglobal("DHUD2_"..bar.."_Texture")
        local point, parent, relative, x, y, width, height, x0, x1, y0, y1, path, tex_height, tex_gap_top, tex_gap_bottom = unpack( self.Layouts[self.db.profile.layout].bars[bar] )        
        local tex_gap_top_p    = tex_gap_top / tex_height
        local tex_gap_bottom_p = tex_gap_bottom / tex_height
        local h = (tex_height - tex_gap_top - tex_gap_bottom) * percent
        local top    = 1-(percent-(tex_gap_top_p))
        local bottom = 1-tex_gap_bottom_p
        top = top  - ((tex_gap_top_p+tex_gap_bottom_p)*(1-percent))
        texture:SetHeight(h)
        texture:SetTexCoord(x0, x1, top, bottom )
        texture:SetPoint(point, getglobal("DHUD2_"..bar), relative, x, tex_gap_bottom)
        texture:Show()
    end

    function setBarColor(bar, percent)
        local r, g, b, hex
        local typ  = string_find(bar, "%u")
        local typunit = getTypUnit(string_sub (bar, 1, typ-1), string_sub (bar, typ))
        local texture = getglobal("DHUD2_"..bar.."_Texture")
        r, g, b, hex = colorize(typunit, percent)
        texture:SetVertexColor(r, g, b)
        return hex
    end
    
end
--[[
DHUD2.getHealth = getHealth
DHUD2.getPower = getPower
DHUD2.setBarHeight = setBarHeight
DHUD2.setBarColor = setBarColor
]]--

local delayTime
local updateBar, updateBarText, updateCombos, updatePlayerPvP, updatePlayerAuras, updateTargetAuras, updatePetIcon, updateTargetIcon, updateText, updateCastText
do
    function updateBar(frame, maxval, curval, fracval)
        local color
        setBarHeight(frame, fracval)
        color = setBarColor(frame, fracval)
        updateBarText(frame, color, maxval, curval, fracval)
    end

    function updateBarText(frame, color, maxval, curval, frac)
        local p = self.db.profile
        local percent = math_floor(frac * 100)
        local font = getglobal("DHUD2_"..frame.."_Text_Text")
        local text = styles.values[p.styles[frame]]
        text = string_gsub(text, "<value>", "|cff"..color..curval)
        if text:find("|c") then
            text = string_gsub(text, "<maxval>", maxval)
        else
            text = string_gsub(text, "<maxval>", "|cff"..color..maxval)
        end
        if text:find("|c") then
            text = string_gsub(text, "<percent>", "|r |cff747070(|r"..percent.."|cff747070)|r%%")
        else
            text = string_gsub(text, "<percent>", "|cff747070(|r"..percent.."|cff747070)|r%%")
        end
        font:SetText(text)
        font:SetWidth(2000);
        local w = font:GetStringWidth() + 10
        font:SetWidth(w)
        getglobal("DHUD2_"..frame.."_Text"):SetWidth(w)
    end
    
    function updateCombos()
        local points = GetComboPoints()
        for i = 1, 5 do
            local combo = getglobal("DHUD2_combo"..i)
            if i <= points then
                combo:Show()
            else
                combo:Hide()
            end
        end
    end
    
    function updatePlayerPvP()
        local p = self.db.profile
        local texture = getglobal("DHUD2_playerPvP_Texture")
        if p.show.playerpvpicon and isAlive then
            local _, _, _, _, _, _, _, x0, x1, y0, y1, path = unpack(self.Layouts[p.layout].icons.playerPvP)
            if UnitIsPVPFreeForAll("player")  then
                path = path[3]
            elseif UnitIsPVP("player") then 
                local faction = UnitFactionGroup("player")
                if faction == "Horde" then
                    path = path[2]
                else
                    path = path[1]
                end
            else
                getglobal("DHUD2_playerPvP"):Hide()
                return
            end
            texture:SetTexture(path)
            texture:SetTexCoord(x0,x1,y0,y1)
            getglobal("DHUD2_playerPvP"):Show()
        else
            getglobal("DHUD2_playerPvP"):Hide()
        end
    end

    function updatePlayerAuras()
        local i, icon
        local j = 1
        local p = self.db.profile
        local r,b,g,hex
        if p.show.playerbuffs then
            for i = 1, 40 do
                local buffI = GetPlayerBuff( i, "HELPFUL" )
                local timeLeft = GetPlayerBuffTimeLeft(buffI)            
                if timeLeft > 0 and timeLeft < p.playerbufftimefilter then
                    r, g, b, hex = colorize("playerAura", timeLeft / 20)
                    local button = getglobal("DHUD2_playerBuff"..j)
                    button.hasbuff = true
                    button.auraTimer = 0
                    button.duration = floor(timeLeft)
                    button.id = buffI
                    button:SetNormalTexture(GetPlayerBuffTexture(buffI))
                    local buffBorder = getglobal("DHUD2_playerBuff"..j.."_Border")
                    buffBorder:SetVertexColor(r, g, b)
                    --buffBorder:SetAlpha(1)
                    buffBorder:Show()
                    local buffText = getglobal("DHUD2_playerBuff"..j.."_Text")
                    buffText:SetText("|cff"..hex..formatTime(button.duration))
                    button:SetScript("OnUpdate", self.OnUpdateAura)
                    button:EnableMouse(true)
                    button:Show()
                    if j == 16 then
                        self:Print("You have reached the buff limit. Contact Arcanefoam and ask for more buff slots")
                        break
                    else
                        j = j + 1
                    end
                end
            end
        end
        for i = j, 16 do
            local button = getglobal("DHUD2_playerBuff"..i)
            button.id = 0
            button.hasbuff = false
            button:SetScript("OnUpdate", nil)
            button:EnableMouse(false)
            button:Hide()
        end
    end
    
    function updateTargetAuras(show)
        local i
        local buffBorder, buffText, buffFrame
        local debuffBorder, debuffText, debuffFrame
        local p = self.db.profile
        if not p.swaptargetAuras then
            buffFrame   = "DHUD2_Buff";
            debuffFrame = "DHUD2_deBuff";
        else
            debuffFrame = "DHUD2_Buff";
            buffFrame   = "DHUD2_deBuff";    
        end
        -- Buffs
        for i = 1, 40 do
            local button = getglobal(buffFrame..i)
            local buffName, _, buffTexture, buffApplication = UnitBuff("target", i)
            if show and buffName then
                button.hasbuff = true
                button.unit = "target"
                button.id = i    
                local icon = getglobal(button:GetName())
                icon:SetNormalTexture(buffTexture)     
                local buffBorder = getglobal(button:GetName().."_Border")
                buffBorder:Hide()            
                local buffText = getglobal(button:GetName().."_Text")
                if buffApplication <= 1 then
                    buffText:SetText("")
                elseif buffApplication > 1 then
                    buffText:SetText(buffApplication)
                end
                button:Show()
            else    
                button:Hide()
            end
        end        
        -- DeBuffs
        for i = 1, 40 do
            local button = getglobal(debuffFrame..i)
            local debuffName, _, debuffTexture, debuffApplication = UnitDebuff("target", i)
            if show and debuffName then
                button.hasdebuff = 1
                button.unit = "target"
                button.id = i
                local icon = getglobal(button:GetName())
                icon:SetNormalTexture(debuffTexture)
                local debuffBorder = getglobal(button:GetName().."_Border")
                debuffBorder:Show()
                local debuffText = getglobal(button:GetName().."_Text")
                if debuffApplication <= 1 then
                    debuffText:SetText("")
                elseif debuffApplication > 1 then
                    debuffText:SetText(debuffApplication)
                end
                button:Show();
            else
                button:Hide();
            end
        end
    end

    function updatePetIcon(health, happiness)
        local p = self.db.profile
        --self:Debug("updatePetIcon", health, happiness)
        if health > 0 and happiness then
            local _, texture, x0, x1, y0, y1 = unpack( self.Layouts[p.layout].images.pet[happiness] )
            if texture then
                local tex = getglobal("DHUD2_petHappy_Texture")
                tex:SetTexture(texture)
                tex:SetTexCoord(x0, x1, y0, y1)
                getglobal("DHUD2_petHappy"):Show()
            else
                getglobal("DHUD2_petHappy"):Hide()
            end
        else
            getglobal("DHUD2_petHappy"):Hide()
        end
    end

    function updateTargetIcon(show)    
        local p = self.db.profile
        if p.show.targetpvpicon and show then
            local _, _, _, _, _, _, _, x0, x1, y0, y1, path = unpack(self.Layouts[p.layout].icons.playerPvP)
            if UnitIsPVPFreeForAll("target")  then
                path = path[3]
            elseif UnitIsPVP("target") then 
                local faction = UnitFactionGroup("target")
                if faction == "Horde" then
                    path = path[2]           
                else
                    path = path[1]                
                end
            else
                local index = GetRaidTargetIndex("target")
                if index then
                    if index > 0 and index <= 8 then
                        path, x0, x1, y0, y1 = unpack( self.Layouts[p.layout].raidIcons[index] )
                    end
                end
            end
            local texture = getglobal("DHUD2_targetIcon_Texture")
            texture:SetTexture(path)
            texture:SetTexCoord(x0,x1,y0,y1)
            getglobal("DHUD2_targetIcon"):Show()
        else
            getglobal("DHUD2_targetIcon"):Hide()
        end
end
    
    --Upodate Target and TargetTarget text
    function updateText(show, unit)
        local p = self.db.profile
        if show then
            local font = getglobal("DHUD2_"..unit.."_Text_Text")
            local text = styles.names[p.styles[unit]]
            local level = UnitLevel(unit)
            local levelText, addLevel
            levelText = level < 0 and "??" or level
            level = level < 0 and 99 or level
            local levColor = GetDifficultyColor(level)
            local color = rgb2hex(levColor.r, levColor.g, levColor.b)
            text, addLevel = string_gsub(text, "<level>", "|cff"..color..levelText)
            local _, eliteText = checkElite(unit)
            if addLevel == 1 then
                text = string_gsub(text, "<elite>", ""..eliteText.."|r")
            else
                text = string_gsub(text, "<elite>", "|cff"..color..eliteText.."|r")
            end
            text = string_gsub(text, "<name>", "|cff"..getReactionColor(unit)..UnitName(unit).."|r")
            local localClass, class = UnitClass(unit)
            color = classColors[class]        
            if not(unitIsNPC(unit) or unitIsPet(unit)) then            
                if not UnitIsPlayer(unit) then
                    localClass = UnitCreatureType(unit)
                end
                text = string_gsub(text, "<class>", "|cff"..color..localClass.."|r")
            else
                text = string_gsub(text, "<class>", "")
            end
            if unitIsPet(unit) then
                text = string_gsub(text, "<pet>", "|cff"..color.."Pet".."|r")
            else
                text = string_gsub(text, "<pet>", "")
            end
            if unitIsNPC(unit) then
                color = "ffff9a"
                text = string_gsub(text, "<npc>", "|cff"..color.."NPC".."|r")            
            else
                text = string_gsub(text, "<npc>", "")
            end
            font:SetText(text)
            font:SetWidth(2000)
            local w = font:GetStringWidth() + 10
            font:SetWidth(w)
            getglobal("DHUD2_"..unit.."_Text"):SetWidth(w)
        end
    end
    
    function updateCastText(cast)
        local font = getglobal("DHUD2_castTime_Text_Text")
        local castText = string_format("%.1f", cast)
        font:SetText(castText)
        font:SetWidth(2000)
        local w = font:GetStringWidth() + 10
        font:SetWidth(w)
        getglobal("DHUD2_castTime_Text"):SetWidth(w)        
        font = getglobal("DHUD2_castDelay_Text_Text")
        local delayText = string_format("%.1f", delayTime)
        font:SetText(delayText)
        font:SetWidth(2000)
        w = font:GetStringWidth() + 10
        font:SetWidth(w)
        getglobal("DHUD2_castDelay_Text"):SetWidth(w)        
    end

end
--[[
DHUD2.updateBar = updateBar
DHUD2.updateBarText = updateBarText
DHUD2.updateCombos = updateCombos
DHUD2.updatePlayerPvP = updatePlayerPvP
DHUD2.updatePlayerAuras = updatePlayerAuras
DHUD2.updateTargetAuras = updateTargetAuras
DHUD2.updatePetIcon = updatePetIcon
DHUD2.updateTargetIcon = updateTargetIcon
DHUD2.updateText = updateText
DHUD2.updateCastText = updateCastText
]]

local updateAlpha, setAlpha, addBackgroundBorder, showFrames, getPetBorder, positionFrame, getTargetBorder, setFonts
do
    function updateAlpha()
        if isDead then
            setAlpha("dead")
        elseif inCombat then
            setAlpha("combat")    
        elseif hasTarget then
            setAlpha("select")
        elseif playerNeedH or playerNeedP or petNeedH or petNeedP then
            setAlpha("regen")
        elseif isCasting then
            setAlpha("regen")	    		       
        else
            setAlpha("ooc")
        end
    end

    function setAlpha(alpha) -- ok
        local p = self.db.profile
        getglobal("DHUD2_leftFrame"):SetAlpha(p.alphas[alpha])
        getglobal("DHUD2_rightFrame"):SetAlpha(p.alphas[alpha])
        addBackgroundBorder(petBorder..targetBorder)
    end

    function addBackgroundBorder(border)
        local p = self.db.profile
        if p.show.barborders then
            local images = self.Layouts[p.layout].images
            local x0, x1, y0, y1, paths  = unpack(images.left)
            texture = paths["l_".."ph_pm"..border]
            if texture then
                getglobal("DHUD2_leftFrame_Texture"):SetTexture(texture)
                getglobal("DHUD2_leftFrame_Texture"):SetTexCoord(x0,x1,y0,y1)
            else
                self:Print("addBackgroundBorder->No left path for: ".."ph_pm"..border)
            end
            x0, x1, y0, y1, paths = unpack(images.right)
            texture = paths["r_".."ph_pm"..border]
            if texture then
                getglobal("DHUD2_rightFrame_Texture"):SetTexture(texture);
                getglobal("DHUD2_rightFrame_Texture"):SetTexCoord(x0,x1,y0,y1)
            else
                self:Print("addBackgroundBorder->No right path for: ".."ph_pm"..border)  
            end        
        end
    end

    function showFrames(unit, show)
        local p = self.db.profile
        if unit == "target" then
            if show then
                getglobal("DHUD2_targetHealth"):Show()
                getglobal("DHUD2_targetHealth_Text"):Show()
                getglobal("DHUD2_targetPower"):Show()
                getglobal("DHUD2_targetPower_Text"):Show()
                local elite = checkElite("target")
                if elite and p.show.eliteicon then
                    local images = self.Layouts[p.layout].images
                    local _, _, _, _, paths = unpack(images.left)
                    local texture = paths[elite]
                    getglobal("DHUD2_targetElite_Texture"):SetTexture(texture)
                    getglobal("DHUD2_targetElite"):Show()
                else
                    getglobal("DHUD2_targetElite"):Hide()
                end
                getglobal("DHUD2_target_Text"):Show()                
            else
                getglobal("DHUD2_targetHealth"):Hide()
                getglobal("DHUD2_targetPower"):Hide()
                getglobal("DHUD2_targetHealth_Text"):Hide()
                getglobal("DHUD2_targetPower_Text"):Hide()
                getglobal("DHUD2_targetElite"):Hide()
                getglobal("DHUD2_target_Text"):Hide()
            end
        elseif unit == "pet" then
            if show then
                getglobal("DHUD2_petHealth"):Show()
                getglobal("DHUD2_petHealth_Text"):Show()
                getglobal("DHUD2_petPower"):Show()
                getglobal("DHUD2_petPower_Text"):Show()
                --getglobal("DHUD2_petHappy"):Show()
            else
                getglobal("DHUD2_petHealth"):Hide()
                getglobal("DHUD2_petHealth_Text"):Hide()
                getglobal("DHUD2_petPower"):Hide()
                getglobal("DHUD2_petPower_Text"):Hide()
                getglobal("DHUD2_petHappy"):Hide()
            end
        else
            if show then 
                getglobal("DHUD2_targetTarget_Text"):Show()
            else
                getglobal("DHUD2_targetTarget_Text"):Hide()
            end
        end    
    end

    function getPetBorder(health, power)
        local border = ""
        if health > 0 then 
            border = "_eh"
        end
        if power > 0 then
            border = border.."_em"
        end
        return border
    end

    function positionFrame(name, x2, y2)
        local p = self.db.profile
        local xn , yn, mx, my = unpack ( p.moveFrame[name])
        local x2 = tonumber(config[xn] or 0)
        local y2 = tonumber(config[yn] or 0)
        if mx == "-" then
            x2 = 0 - x2
        end
        if my == "-" then
            y2 = 0 - y2
        end
        local ref = ""
        local point, parent, relative, x, y, width, height = unpack( self.Layouts[p.layout].mainFrame )        
        if name == "mainFrame" then        
            ref = getglobal("DHUD2_"..name)
            ref:SetPoint(point, parent, relative, x + x2, y + y2)
            return
        elseif string_find(name, "Frame") then
            point, parent, relative, x, y, width, height = unpack( self.Layouts[p.layout].frames[name] )
            ref = getglobal("DHUD2_"..name)
        else
            point, parent, relative, x, y, width, height = unpack( self.Layouts[p.layout].text[name] )
            ref = getglobal("DHUD2_"..name.."_Text")
        end
        ref:SetPoint(point, "DHUD2_"..parent, relative, x + x2, y + y2)
    end

    function getTargetBorder(health, power)
        local border = ""
        if health > 0 then 
            border = "_th"
        end
        if power > 0 then 
            border = border.."_tm"
        end
        return border
    end
    
    function setFonts()
        local p = self.db.profile
        for i = 1, 16 do            
            local text = getglobal("DHUD2_playerBuff"..i.."_Text")
            text:SetFont( defaultfont_num, p.fontsize.playerBuff / p.scale, p.outlines.playerBuff)
        end
        DHUD2_playerHealth_Text_Text:SetFont(defaultfont_num, p.fontsize.player / p.scale, p.outlines.playerHealth)
        DHUD2_playerPower_Text_Text:SetFont(defaultfont_num, p.fontsize.player / p.scale, p.outlines.playerPower)
        DHUD2_targetHealth_Text_Text:SetFont(defaultfont_num, p.fontsize.target / p.scale, p.outlines.targetHealth)
        DHUD2_targetPower_Text_Text:SetFont(defaultfont_num, p.fontsize.target / p.scale, p.outlines.targetPower)
        DHUD2_petHealth_Text_Text:SetFont(defaultfont_num, p.fontsize.pet / p.scale, p.outlines.petHealth)
        DHUD2_petPower_Text_Text:SetFont(defaultfont_num, p.fontsize.pet / p.scale, p.outlines.petPower)
        DHUD2_castDelay_Text_Text:SetFont(defaultfont_num, p.fontsize.castDelay / p.scale, p.outlines.castDelay)
        DHUD2_castTime_Text_Text:SetFont(defaultfont_num, p.fontsize.castTime / p.scale, p.outlines.castTime)        
        DHUD2_target_Text_Text:SetFont(defaultfont, p.fontsize.targetName / p.scale, p.outlines.target)
        DHUD2_targetTarget_Text_Text:SetFont(defaultfont, p.fontsize.targetTargetName / p.scale, p.outlines.targetTarget)
    end
end
--[[
DHUD2.setFonts = setFonts
DHUD2.updateAlpha = updateAlpha
]]

local castTimer = 0
local spellDuration, isChanneling, barFadeOut, barFlash, finishTime, fadeAlpha
local OnShow, OnHide, OnUpdateAura, OnUpdateCast, OnUpdateFlash
do 
    function OnShow(this)
        castTimer = 0
        getglobal("DHUD2_casting"):SetScript("OnUpdate", OnUpdateCast)
    end

    function OnHide(this)
        castTimer = nil
        getglobal("DHUD2_casting"):SetScript("OnUpdate", nil)
    end

    function OnUpdateAura(this, elapsed)
        this.auraTimer = this.auraTimer + elapsed
        if this:GetEffectiveAlpha() == 0 then
            this:EnableMouse(false)
        else            
            this:EnableMouse(true)
            if this.auraTimer >= auraUpdateInterval then
                local timeLeft = math_floor(GetPlayerBuffTimeLeft(this.id))
                this.duration = timeLeft
                --self:Debug(this:GetEffectiveAlpha())
                this:SetNormalTexture(GetPlayerBuffTexture(this.id))
                local r, g, b, hex = colorize("playerAura", this.duration / 20)
                local buffBorder = getglobal(this:GetName().."_Border")
                buffBorder:SetVertexColor(r, g, b)
                local buffText = getglobal(this:GetName().."_Text")
                buffText:SetText("|cff"..hex..formatTime(this.duration))
                this.auraTimer = 0
            end
        end
        
    end
    
    function OnUpdateCast(this, elapsed)
        local p = self.db.profile
        castTimer = castTimer + elapsed
        if isCasting then
            local value = castTimer / (spellDuration + delayTime) 
            DHUD2_casting_Texture:SetVertexColor(colorize("casting", value))
            if p.reversecasting then
                cast = (spellDuration + delayTime) - castTimer
                setBarHeight("casting", 1 - value)        
            else
                cast = castTimer
                setBarHeight("casting", value)
            end            
            updateCastText(cast)
        elseif isChanneling then
            local value = castTimer / (spellDuration + delayTime)
            setBarHeight("casting", value )
            DHUD2_casting_Texture:SetVertexColor(colorize("channelBar",value))
            updateCastText(castTimer)        
        elseif barFadeOut then
            fadeAlpha = this:GetAlpha() - CASTING_BAR_ALPHA_STEP
            if fadeAlpha > 0 then
                this:SetAlpha(fadeAlpha)
                DHUD2_castTime_Text:SetAlpha(fadeAlpha)
                DHUD2_castDelay_Text:SetAlpha(fadeAlpha)
            else
                barFadeOut = false
                this:SetScript("OnUpdate", nil)
                this:Hide()
                this:SetAlpha(1)
                DHUD2_castTime_Text:SetAlpha(1)
                DHUD2_castDelay_Text:SetAlpha(1)
                updateCastText(0)
                updateAlpha()
            end 
        end
    end
    
    function OnUpdateFlash(this)
        if barFlash then
            fadeAlpha = this:GetAlpha() + CASTING_BAR_FLASH_STEP
            if fadeAlpha < 1 then
                this:SetAlpha(fadeAlpha)
            else
                barFlash = false            
                this:SetScript("OnUpdate", nil)
                this:Hide()
                this:SetAlpha(1)
                updateAlpha()
            end            
        end
    end
end
DHUD2.OnShow = OnShow
DHUD2.OnHide = OnHide
DHUD2.OnUpdateAura = OnUpdateAura
DHUD2.OnUpdateCast = OnUpdateCast
DHUD2.OnUpdateFlash = OnUpdateFlash

local isInit = false
function DHUD2:OnInitialize()
    --self:SetDebugging(true)
    if AceLibrary:HasInstance("Waterfall-1.0") then
		AceLibrary("Waterfall-1.0"):Register('DHUD2',
			'aceOptions', options,
			'title', L["DHUD2"],
			'treeLevels', 4,
			'colorR', 0.6, 'colorG', 0.6, 'colorB', 0.8
		)
		self:RegisterChatCommand({"/dhud2"}, function()
			AceLibrary("Waterfall-1.0"):Open('DHUD2')
		end)
		if AceLibrary:HasInstance("Dewdrop-2.0") then
			self:RegisterChatCommand({"/dhud2dd"}, function()
				AceLibrary("Dewdrop-2.0"):Open('DHDUD2', 'children', function()
					AceLibrary("Dewdrop-2.0"):FeedAceOptionsTable(options)
				end)
			end)
		end
		self:RegisterChatCommand({"/dhud2cl"}, options)
	elseif AceLibrary:HasInstance("Dewdrop-2.0") then
		self:RegisterChatCommand({"/dhud2"}, function()
			AceLibrary("Dewdrop-2.0"):Open('DHUD2', 'children', function()
				AceLibrary("Dewdrop-2.0"):FeedAceOptionsTable(options)
			end)
		end)
		self:RegisterChatCommand({"/dhud2cl"}, options)
	else
		self:RegisterChatCommand({"/dhud2"}, options)
	end
    self:SetIcon("Interface\\AddOns\\DHUD2\\icon.tga")
    -- MyAddons Support
    self:_myAddons()
    isInit = true
end

local isSetup = false
function blizzFrames(self, showPlayer, showTarget, showPet, showCasting)
    if showTarget then
        TargetFrame:RegisterEvent("PLAYER_TARGET_CHANGED")
        TargetFrame:RegisterEvent("UNIT_HEALTH")
        TargetFrame:RegisterEvent("UNIT_LEVEL")
        TargetFrame:RegisterEvent("UNIT_FACTION")
        TargetFrame:RegisterEvent("UNIT_CLASSIFICATION_CHANGED")
        TargetFrame:RegisterEvent("UNIT_AURA")
        TargetFrame:RegisterEvent("PLAYER_FLAGS_CHANGED")
        TargetFrame:RegisterEvent("PARTY_MEMBERS_CHANGED")
        TargetFrame:RegisterEvent("PLAYER_FOCUS_CHANGED")
        if UnitExists("target") then TargetFrame:Show() end
        ComboFrame:RegisterEvent("PLAYER_TARGET_CHANGED")
        ComboFrame:RegisterEvent("PLAYER_COMBO_POINTS")
    else
        TargetFrame:UnregisterEvent("PLAYER_TARGET_CHANGED")
        TargetFrame:UnregisterEvent("UNIT_HEALTH")
        TargetFrame:UnregisterEvent("UNIT_LEVEL")
        TargetFrame:UnregisterEvent("UNIT_FACTION")
        TargetFrame:UnregisterEvent("UNIT_CLASSIFICATION_CHANGED")
        TargetFrame:UnregisterEvent("UNIT_AURA")
        TargetFrame:UnregisterEvent("PLAYER_FLAGS_CHANGED")
        TargetFrame:UnregisterEvent("PARTY_MEMBERS_CHANGED")
        TargetFrame:UnregisterEvent("PLAYER_FOCUS_CHANGED")
        ComboFrame:UnregisterEvent("PLAYER_TARGET_CHANGED")
        ComboFrame:UnregisterEvent("PLAYER_COMBO_POINTS")
        TargetFrame:Hide()
        ComboFrame:Hide()
    end
    
    if showPlayer then
        PlayerFrame:RegisterEvent("UNIT_LEVEL")
        PlayerFrame:RegisterEvent("UNIT_COMBAT")
        PlayerFrame:RegisterEvent("UNIT_SPELLMISS")
        PlayerFrame:RegisterEvent("UNIT_PVP_UPDATE")
        PlayerFrame:RegisterEvent("UNIT_MAXMANA")
        PlayerFrame:RegisterEvent("PLAYER_ENTER_COMBAT")
        PlayerFrame:RegisterEvent("PLAYER_LEAVE_COMBAT")
        PlayerFrame:RegisterEvent("PLAYER_UPDATE_RESTING")
        PlayerFrame:RegisterEvent("PARTY_MEMBERS_CHANGED")
        PlayerFrame:RegisterEvent("PARTY_LEADER_CHANGED")
        PlayerFrame:RegisterEvent("PARTY_LOOT_METHOD_CHANGED")
        PlayerFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
        PlayerFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
        PlayerFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
        PlayerFrameHealthBar:RegisterEvent("UNIT_HEALTH")
        PlayerFrameHealthBar:RegisterEvent("UNIT_MAXHEALTH")
        PlayerFrameManaBar:RegisterEvent("UNIT_MANA")
        PlayerFrameManaBar:RegisterEvent("UNIT_RAGE")
        PlayerFrameManaBar:RegisterEvent("UNIT_FOCUS")
        PlayerFrameManaBar:RegisterEvent("UNIT_ENERGY")
        PlayerFrameManaBar:RegisterEvent("UNIT_HAPPINESS")
        PlayerFrameManaBar:RegisterEvent("UNIT_MAXMANA")
        PlayerFrameManaBar:RegisterEvent("UNIT_MAXRAGE")
        PlayerFrameManaBar:RegisterEvent("UNIT_MAXFOCUS")
        PlayerFrameManaBar:RegisterEvent("UNIT_MAXENERGY")
        PlayerFrameManaBar:RegisterEvent("UNIT_MAXHAPPINESS")
        PlayerFrameManaBar:RegisterEvent("UNIT_DISPLAYPOWER")
        PlayerFrame:RegisterEvent("UNIT_NAME_UPDATE")
        PlayerFrame:RegisterEvent("UNIT_PORTRAIT_UPDATE")
        PlayerFrame:RegisterEvent("UNIT_DISPLAYPOWER")
        PlayerFrame:Show()
    else
        PlayerFrame:UnregisterEvent("UNIT_LEVEL")
        PlayerFrame:UnregisterEvent("UNIT_COMBAT")
        PlayerFrame:UnregisterEvent("UNIT_SPELLMISS")
        PlayerFrame:UnregisterEvent("UNIT_PVP_UPDATE")
        PlayerFrame:UnregisterEvent("UNIT_MAXMANA")
        PlayerFrame:UnregisterEvent("PLAYER_ENTER_COMBAT")
        PlayerFrame:UnregisterEvent("PLAYER_LEAVE_COMBAT")
        PlayerFrame:UnregisterEvent("PLAYER_UPDATE_RESTING")
        PlayerFrame:UnregisterEvent("PARTY_MEMBERS_CHANGED")
        PlayerFrame:UnregisterEvent("PARTY_LEADER_CHANGED")
        PlayerFrame:UnregisterEvent("PARTY_LOOT_METHOD_CHANGED")
        PlayerFrame:UnregisterEvent("PLAYER_ENTERING_WORLD")
        PlayerFrame:UnregisterEvent("PLAYER_REGEN_DISABLED")
        PlayerFrame:UnregisterEvent("PLAYER_REGEN_ENABLED")
        PlayerFrameHealthBar:UnregisterEvent("UNIT_HEALTH")
        PlayerFrameHealthBar:UnregisterEvent("UNIT_MAXHEALTH")
        PlayerFrameManaBar:UnregisterEvent("UNIT_MANA")
        PlayerFrameManaBar:UnregisterEvent("UNIT_RAGE")
        PlayerFrameManaBar:UnregisterEvent("UNIT_FOCUS")
        PlayerFrameManaBar:UnregisterEvent("UNIT_ENERGY")
        PlayerFrameManaBar:UnregisterEvent("UNIT_HAPPINESS")
        PlayerFrameManaBar:UnregisterEvent("UNIT_MAXMANA")
        PlayerFrameManaBar:UnregisterEvent("UNIT_MAXRAGE")
        PlayerFrameManaBar:UnregisterEvent("UNIT_MAXFOCUS")
        PlayerFrameManaBar:UnregisterEvent("UNIT_MAXENERGY")
        PlayerFrameManaBar:UnregisterEvent("UNIT_MAXHAPPINESS")
        PlayerFrameManaBar:UnregisterEvent("UNIT_DISPLAYPOWER")
        PlayerFrame:UnregisterEvent("UNIT_NAME_UPDATE")
        PlayerFrame:UnregisterEvent("UNIT_PORTRAIT_UPDATE")
        PlayerFrame:UnregisterEvent("UNIT_DISPLAYPOWER")
        PlayerFrame:Hide()
    end    
    
    if showCasting then
        CastingBarFrame:RegisterEvent("UNIT_SPELLCAST_START");
        CastingBarFrame:RegisterEvent("UNIT_SPELLCAST_STOP");
        CastingBarFrame:RegisterEvent("UNIT_SPELLCAST_FAILED");
        CastingBarFrame:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED");
        CastingBarFrame:RegisterEvent("UNIT_SPELLCAST_DELAYED");
        CastingBarFrame:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START");
        CastingBarFrame:RegisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE");
        CastingBarFrame:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP");
    else
        CastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_START")
        CastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_STOP")
        CastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_FAILED")
        CastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_INTERRUPTED")        
        CastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_DELAYED")
        CastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_CHANNEL_START")
        CastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE")
        CastingBarFrame:UnregisterEvent("UNIT_SPELLCAST_CHANNEL_STOP")
        CastingBarFrame:Hide()
    end
    
    if showPet then
        
    end      
end
DHUD2.blizzFrames = blizzFrames
  
function DHUD2:setup()
    local playerMaxH, playerCurH, playerCurHFrac, playerMaxP, playerCurP, playerCurPFrac, petMaxH, petCurH, petCurHFrac, petMaxP, petCurP, petCurPFrac
    local p = self.db.profile
    DHUD2_mainFrame:SetScale(p.scale)
    local _, class = UnitClass("player")
    if class == "DRUID" then
        isDruid = true
        showFrames("pet", false)
        if p.show.druidbar and SmartyCat then 
            self:RegisterEvent("UNIT_DISPLAYPOWER")
            if UnitPowerType("player") ~= 0 then                
                petBorder = getPetBorder(0, 1)  
                getglobal("DHUD2_petPower"):Show()
                self:RegisterEvent("SmartyCat_ManaUpdated", "OnFormUpdateMana")
                local cur, max = SmartyCat.GetCurrMana(), SmartyCat.GetMaxMana()
                updateBar("petPower", max, cur, cur/max)
            end
        end
    else
        --Init Pet frames
        hasPet = UnitExists("pet")
        if hasPet and p.show.pet then
            happ = GetPetHappiness()
            petMaxH, petCurH, petCurHFrac, petNeedH = getHealth("pet")
            petMaxP, petCurP, petCurPFrac, petNeedP = getPower("pet", UnitPowerType("pet"))
            updateBar("petHealth", petMaxH, petCurH, petCurHFrac)
            updateBar("petPower", petMaxH, petCurH, petCurPFrac)
            petBorder = getPetBorder(petMaxH, petMaxP)
            updatePetIcon(petCurH, happ)
        else
            updatePetIcon(0)
            petBorder = getPetBorder(0, 0)
            updateBar("petHealth", 0, 0, 0)
            updateBar("petPower", 0, 0, 0)
        end
        showFrames("pet", hasPet)
    end
    isAlive = not UnitIsDeadOrGhost("player")
    isDead = not isAlive
    playerMaxH, playerCurH, playerCurHFrac, playerNeedH = getHealth("player")
    playerMaxP, playerCurP, playerCurPFrac, playerNeedP = getPower("player", UnitPowerType("player"))
    updateBar("playerHealth", playerMaxH, playerCurH, playerCurHFrac)
    updateBar("playerPower", playerMaxP, playerCurP, playerCurPFrac)
    updateCombos()
    updatePlayerPvP()
    if IsResting() and p.show.resticon then
        getglobal("DHUD2_playerResting"):Show();
    else
        getglobal("DHUD2_playerResting"):Hide();
    end
    if UnitPlayerOrPetInParty("player") then
        if IsPartyLeader() then
            getglobal("DHUD2_playerLeader"):Show()
            local lootmethod = GetLootMethod()
            if lootmethod == "master" then
                getglobal("DHUD2_playerLooter"):Show()
            else
                getglobal("DHUD2_playerLooter"):Hide()
            end
        else
            getglobal("DHUD2_playerLeader"):Hide()
            getglobal("DHUD2_playerLooter"):Hide()
        end
    else
        getglobal("DHUD2_playerLeader"):Hide()
        getglobal("DHUD2_playerLooter"):Hide()
    end        
    getglobal("DHUD2_playerInCombat"):Hide()
    showFrames("target", false)
    showFrames("targetTarget", false)
    updateTargetAuras(false)
    updateBar("targetHealth", 0, 0, 0)
    updateBar("targetPower", 0, 0, 0)
    updateAlpha()
    getglobal("DHUD2_casting"):Hide()
    getglobal("DHUD2_flash"):Hide()
    
    --Set fonts
    setFonts()
    
    -- Manage Blizz Frames 
    blizzFrames(self, p.show.blizplayer, p.show.bliztarget, p.show.blizpet, p.show.blizcasting)
    

  --[[
    -- pos frames
    positionFrame("mainFrame");
    positionFrame("leftFrame");
    positionFrame("rightFrame");
    positionFrame("target");
    positionFrame("targetTarget");
    positionFrame("playerHealth");
    positionFrame("playerPower");
    positionFrame("targetHealth");
    positionFrame("targetPower");
    positionFrame("petHealth");
    positionFrame("petPower");    
    positionFrame("castTime");
    positionFrame("castDelay");    
   ]]
    isSetup = true
end

function DHUD2:createFrames()
    -- Get layout information
    local layout = self.db.profile.layout
    local mainFrame = self.Layouts[layout].mainFrame
    local subFrames = self.Layouts[layout].frames
    local icons = self.Layouts[layout].icons
    local bars = self.Layouts[layout].bars
    local texts = self.Layouts[layout].text
    local buffs = self.Layouts[layout].buff
    local debuffs = self.Layouts[layout].deBuff
    local playBuff = self.Layouts[layout].playbuff
  
    -- Main Frame
    local point, parent, relative, x, y, width, height = unpack(mainFrame)
    ref = CreateFrame ("Frame", "DHUD2_mainFrame", getglobal(parent))
    ref:ClearAllPoints()
    ref:SetPoint(point, parent, relative, x, y)
    ref:SetHeight(height)
    ref:SetWidth(width)
    ref:EnableMouse(false)
    ref:Show()
    
    -- Subframes
    for k, v in pairs(subFrames) do
        point, parent, relative, x, y, width, height, x0, x1, y0, y1, path = unpack(v)
        ref = CreateFrame("Frame", "DHUD2_"..k, getglobal("DHUD2_"..parent))
        ref:ClearAllPoints()
        ref:SetPoint(point, "DHUD2_"..parent, relative, x, y)
        ref:SetHeight(height)
        ref:SetWidth(width)
        local bgt = ref:CreateTexture("DHUD2_"..k.."_Texture", "BACKGROUND")
        bgt:SetTexture(path)
        bgt:ClearAllPoints()
        bgt:SetPoint("TOPLEFT", ref , "TOPLEFT", 0, 0)
        bgt:SetPoint("BOTTOMRIGHT", ref , "BOTTOMRIGHT", 0, 0)
        bgt:SetTexCoord(x0, x1, y0, y1)
        ref:EnableMouse(false)
        ref:Show()
    end
    
    -- Bars
    for k, v in pairs(bars) do
        point, parent, relative, x, y, width, height, x0, x1, y0, y1, path = unpack(v)
        ref = CreateFrame("Frame", "DHUD2_"..k, getglobal("DHUD2_"..parent))
        ref:ClearAllPoints()
        ref:SetPoint(point, "DHUD2_"..parent , relative, x, y)
        ref:SetHeight(height)
        ref:SetWidth(width)
        bgt = ref:CreateTexture("DHUD2_"..k.."_Texture", "BACKGROUND")
        bgt:SetTexture(path)
        bgt:SetPoint(point, ref, relative, 0, 0)
        bgt:SetHeight(height)
        bgt:SetWidth(width)
        bgt:SetTexCoord(x0, x1, y0, y1)
        ref:EnableMouse(false)
        --ref:Show()
    end
    
    -- Text
    for k, v in pairs(texts) do
        point, parent, relative, x, y, width, height = unpack(v)
        ref = CreateFrame("Button", "DHUD2_"..k.."_Text", getglobal("DHUD2_"..parent))
        ref:ClearAllPoints()
        ref:SetPoint(point, "DHUD2_"..parent, relative, x, y)
        local font = ref:CreateFontString("DHUD2_"..k.."_Text_Text", "ARTWORK")
        font:SetFontObject(GameFontHighlightSmall)
        font:SetText("")
        font:SetJustifyH("CENTER")
        font:SetWidth(font:GetStringWidth())
        font:SetHeight(height)
        font:Show()
        font:ClearAllPoints()
        font:SetPoint(point, ref, relative, 0, 0)
        ref:SetHeight(height)
        ref:SetWidth(font:GetStringWidth())
        ref:EnableMouse(false)
        --ref:Show()
    end
    
    -- Icons
    for k, v in pairs(icons) do
        point, parent, relative, x, y, width, height, x0, x1, y0, y1, path = unpack(v)
        if string_find(k, "PvP") then         
            local faction = UnitFactionGroup("player")
            if faction == "Horde" then
                path = path[2]
            else
                path = path[1]
            end
        end
        ref = CreateFrame("Frame", "DHUD2_"..k, getglobal("DHUD2_"..parent))
        ref:ClearAllPoints()
        ref:SetPoint(point, "DHUD2_"..parent, relative, x, y)
        ref:SetHeight(height)
        ref:SetWidth(width)
        local bgt = ref:CreateTexture("DHUD2_"..k.."_Texture","BACKGROUND")
        bgt:SetTexture(path)
        bgt:ClearAllPoints()
        bgt:SetPoint("TOPLEFT", ref , "TOPLEFT", 0, 0)
        bgt:SetPoint("BOTTOMRIGHT", ref , "BOTTOMRIGHT", 0, 0)
        bgt:SetTexCoord(x0,x1,y0,y1)
        ref:EnableMouse(false)
        --ref:Show()
    end
    
    -- Target Buffs/Debuffs
    for i = 1, 40 do
        point, parent, relative, x, y, width, height = unpack(buffs["Buff"..i])
        ref = CreateFrame("Button", "DHUD2_Buff"..i, getglobal("DHUD2_"..parent))
        ref:ClearAllPoints()
        ref:SetPoint(point, "DHUD2_"..parent, relative, x, y)
        ref:SetHeight(height)
        ref:SetWidth(width)
        local font = ref:CreateFontString("DHUD2_Buff"..i.."_Text", "ARTWORK")
        font:SetFontObject(GameFontHighlightSmall)
        font:SetText("")
        font:SetJustifyH("RIGHT")
        font:SetJustifyV("BOTTOM")
        font:SetWidth(width+1)
        font:SetHeight(height-5)
        font:SetFont("FRIZQT__.TTF", width / 2.2, "OUTLINE")
        font:Show()
        font:ClearAllPoints()
        font:SetPoint(point, "DHUD2_"..parent, relative, x, y)
        bgt = ref:CreateTexture("DHUD2_Buff"..i.."_Border", "OVERLAY")
        bgt:SetTexture("Interface\\Buttons\\UI-Debuff-Border")
        bgt:SetPoint("BOTTOM", ref, "BOTTOM", 0, 0)
        bgt:SetHeight(height)
        bgt:SetWidth(width)
        bgt:SetTexCoord(0, 1, 0, 1)
        ref:SetNormalTexture( "Interface\\Icons\\Ability_Druid_TravelForm" )
        ref:SetScript("OnEnter", function(this)
                if not (this:IsVisible() and self.db.profile.show.auratips) then
                    return
                end
                GameTooltip:SetOwner(this, "ANCHOR_BOTTOMRIGHT")
                if this.hasdebuff then
                    GameTooltip:SetUnitDebuff(this.unit, this.id)
                else
                    GameTooltip:SetUnitBuff(this.unit, this.id)
                end
            end )
        ref:SetScript("OnLeave", function() 
                GameTooltip:Hide()
            end )        
        ref:EnableMouse(true)
        --ref:Show()
    end
    
    for i=1, 40 do
        point, parent, relative, x, y, width, height = unpack(debuffs["deBuff"..i])
        ref = CreateFrame("Button", "DHUD2_deBuff"..i, getglobal("DHUD2_"..parent))
        ref:ClearAllPoints()
        ref:SetPoint(point, "DHUD2_"..parent, relative, x, y)
        ref:SetHeight(height)
        ref:SetWidth(width)
        local font = ref:CreateFontString("DHUD2_deBuff"..i.."_Text", "ARTWORK")
        font:SetFontObject(GameFontHighlightSmall)
        font:SetText("")
        font:SetJustifyH("RIGHT")
        font:SetJustifyV("BOTTOM")
        font:SetWidth(width+1)
        font:SetHeight(height-5)
        font:SetFont("FRIZQT__.TTF", width / 2.2, "OUTLINE")
        font:Show()
        font:ClearAllPoints()
        font:SetPoint(point, "DHUD2_"..parent, relative, x, y)
        bgt = ref:CreateTexture("DHUD2_deBuff"..i.."_Border","OVERLAY")
        bgt:SetTexture("Interface\\Buttons\\UI-Debuff-Border")
        bgt:SetPoint("BOTTOM", ref, "BOTTOM", 0, 0)
        bgt:SetHeight(height)
        bgt:SetWidth(width)
        bgt:SetTexCoord(0, 1, 0, 1)
        ref:SetNormalTexture( "Interface\\Icons\\Ability_Druid_TravelForm" )
        ref:SetScript("OnEnter", function(this)
                if not (this:IsVisible() and self.db.profile.show.auratips) then
                    return
                end
                GameTooltip:SetOwner(this, "ANCHOR_BOTTOMRIGHT")
                if this.hasdebuff then
                    GameTooltip:SetUnitDebuff(this.unit, this.id)
                else
                    GameTooltip:SetUnitBuff(this.unit, this.id)
                end
            end )
        ref:SetScript("OnLeave", function() 
                GameTooltip:Hide()
            end )        
        ref:EnableMouse(true)
        --ref:Show()
    end
    
    -- Player Buff
    for k, v in pairs(playBuff) do
        point, parent, relative, x, y, width, height = unpack(v)
        ref = CreateFrame("Button", "DHUD2_"..k, getglobal("DHUD2_"..parent))
        ref:ClearAllPoints()
        ref:SetPoint(point, "DHUD2_"..parent, relative, x, y)
        ref:SetHeight(height)
        ref:SetWidth(width)
        font = ref:CreateFontString("DHUD2_"..k.."_Text", "OVERLAY")
        font:ClearAllPoints()
        font:SetFontObject(GameFontHighlightSmall)
        font:SetPoint("CENTER", ref, "CENTER", 0,0)
        font:SetText("")
        font:SetJustifyH("CENTER")
        font:SetJustifyV("CENTER")
        font:SetWidth(width*2)
        font:SetHeight(height)
        bgt = ref:CreateTexture("DHUD2_"..k.."_Border", "OVERLAY")
        bgt:SetTexture("Interface\\AddOns\\DHUD2\\Layouts\\serenity0")
        bgt:SetVertexColor(1.0, 1.0, 1.0)
        bgt:SetPoint("TOPLEFT", ref, "TOPLEFT", -7.5, 7.5)
        bgt:SetHeight(height*1.6)
        bgt:SetWidth(width*1.6)
        bgt:SetTexCoord(0, 1, 0, 1)
        bgt:SetBlendMode("DISABLE")                
        ref:SetNormalTexture( "Interface\\Icons\\Ability_Druid_TravelForm" )
        ref:SetScript("OnEnter", function(this) 
                if not (this:IsVisible() and self.db.profile.show.auratips) or (this:GetEffectiveAlpha() == 0) then
                    return
                end
                GameTooltip:SetOwner(this, "ANCHOR_BOTTOMRIGHT")
                GameTooltip:SetPlayerBuff(this.id)
            end )
        ref:SetScript("OnLeave", function() 
                GameTooltip:Hide()
            end )         
        --ref:Hide()
    end
end

function DHUD2:_myAddons()
    if (myAddOnsFrame_Register) then
        local DHUD2_mya = {
            ["name"]         = "DHUD2",
            ["version"]      = versionstring,
            ["author"]       = "Arcanefoam (Horacio Hoyos) -- Drathl/Silberklinge",
            ["category"]     = MYADDONS_CATEGORY_COMBAT,
            ["email"]        = "arcanefoam AT gmail DOT com",
            ["website"]      = "http://wowacwe.com",
            ["optionsframe"] = "DHUD2OptionsFrame",
        }
        myAddOnsFrame_Register(DHUD2_mya)
    end
end

local addonLoaded = false
function DHUD2:OnEnable() -- ok
    self:createFrames()
    self:RegisterEvent("PLAYER_ENTERING_WORLD")
    self:RegisterEvent("UNIT_HEALTH", "onUnitHealth")
    self:RegisterEvent("UNIT_MAXHEALTH", "onUnitHealth")
    self:RegisterEvent("UNIT_MANA", "onUnitPower")
    self:RegisterEvent("UNIT_MAXMANA", "onUnitPower")  
    self:RegisterEvent("UNIT_FOCUS", "onUnitPower")
    self:RegisterEvent("UNIT_MAXFOCUS", "onUnitPower")
    self:RegisterEvent("UNIT_RAGE", "onUnitPower")
    self:RegisterEvent("UNIT_MAXRAGE", "onUnitPower")
    self:RegisterEvent("UNIT_ENERGY", "onUnitPower")
    self:RegisterEvent("UNIT_MAXENERGY", "onUnitPower")
    self:RegisterEvent("UNIT_FACTION")
    self:RegisterEvent("UNIT_AURA")
    self:RegisterEvent("UNIT_TARGET")
    self:RegisterEvent("UNIT_HAPPINESS")
    self:RegisterEvent("UNIT_PET")
    self:RegisterEvent("PLAYER_TARGET_CHANGED")
    self:RegisterEvent("PLAYER_REGEN_ENABLED")
    self:RegisterEvent("PLAYER_REGEN_DISABLED")
    self:RegisterEvent("PLAYER_AURAS_CHANGED")
    self:RegisterEvent("PLAYER_COMBO_POINTS")
    self:RegisterEvent("PLAYER_ALIVE")
    self:RegisterEvent("PLAYER_UNGHOST", "OnPlayerLife")
    self:RegisterEvent("PLAYER_DEAD")
    self:RegisterEvent("PLAYER_UPDATE_RESTING")
    self:RegisterEvent("RAID_TARGET_UPDATE")
    self:RegisterEvent("PARTY_LOOT_METHOD_CHANGED")
    --self:RegisterEvent("PARTY_MEMBERS_CHANGED")

    local p = self.db.profile
    if p.show.target then
        getglobal("DHUD2_target_Text"):RegisterForClicks('RightButtonUp')
        getglobal("DHUD2_target_Text"):SetScript("OnClick", function() 
            ToggleDropDownMenu(1, nil, DHUD2_targetDropDownMenu, "DHUD2_target_Text", 25, 10)
        end )
    end
    if p.show.casting then
        castTimer = 0
        self:RegisterEvent("UNIT_SPELLCAST_START")
        self:RegisterEvent("UNIT_SPELLCAST_STOP")
        self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP")
        self:RegisterEvent("UNIT_SPELLCAST_FAILED", "OnSpellFail")
        self:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED", "OnSpellFail")
        self:RegisterEvent("UNIT_SPELLCAST_DELAYED")
        self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START")
        self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE")
    end
    addonLoaded = true
end

function DHUD2:PLAYER_ENTERING_WORLD()
    if not isInit then
        init()
    end
    if isSetup then
        return
    end
    self:setup()
end

function DHUD2:onUnitHealth(who)
    local p = self.db.profile
    if who == "player" then
        playerMaxH, playerCurH, playerCurHFrac, playerNeedH = getHealth(who)
        updateBar("playerHealth", playerMaxH, playerCurH, playerCurHFrac)
    elseif who == "target" and p.show.target then
        targetMaxH, targetCurH, targetCurHFrac, targetNeedH = getHealth(who)
        updateBar("targetHealth", targetMaxH, targetCurH, targetCurHFrac)
    elseif who == "pet" and hasPet and p.show.pet then
        petMaxH, petCurH, petCurHFrac, petNeedH = getHealth(who)
        updateBar("petHealth", petMaxH, petCurH, petCurHFrac)
    end
    updateAlpha()
end

function DHUD2:onUnitPower(who)
    local p = self.db.profile 
    if who == "player" then
        playerMaxP, playerCurP, playerCurPFrac, playerNeedP = getPower(who, UnitPowerType(who))
        updateBar("playerPower", playerMaxP, playerCurP, playerCurPFrac)
    elseif who == "target" and p.show.target then
        targetMaxP, targetCurP, targetCurPFrac, targetNeedP = getPower(who, UnitPowerType(who))
        updateBar("targetPower", targetMaxP, targetCurP, targetCurPFrac)
    elseif who == "pet" and hasPet and p.show.pet then
        petMaxP, petCurP, petCurPFrac, petNeedP = getPower(who, UnitPowerType(who))
        updateBar("petPower", petMaxP, petCurP, petCurPFrac)
    end
    updateAlpha()
end

function DHUD2:UNIT_FACTION(who)
    local p = self.db.profile
    if who == "player" then
        updatePlayerPvP()
        if UnitIsUnit("player", "target") then
            updateTargetIcon()
        end
    elseif who == "target" and p.show.target then
        updateTargetIcon()
    end
end

function DHUD2:UNIT_AURA(who)
    if who == "target" and self.db.profile.show.target then
        updateTargetAuras(true)
    end
end

function DHUD2:UNIT_TARGET(who)
    local p = self.db.profile
    if who == "target" then
        if UnitExists("targetTarget") and p.show.targetTarget then
            updateText(true, "targetTarget")
            showFrames("targetTarget", true)
        else
            updateText(false, "targetTarget")
            showFrames("targetTarget", false)
        end
    end
    --[[
    -- make name clickable?
    if ( UnitIsUnit("target", "player") and ( GetNumPartyMembers() > 0 or GetNumRaidMembers() > 0 )) or
       ( UnitIsPlayer("target")  and not UnitIsEnemy("player", "target")  and not UnitIsUnit("target", "player") ) or
       UnitIsUnit("target", "pet") then
        getglobal("DHUD2_Target_Text"):EnableMouse(1);
    else
        getglobal("DHUD2_Target_Text"):EnableMouse(0);
    end
    ]]
    -- self:triggerTextEvent("DHUD2_targetTarget_Text");
end

function DHUD2:UNIT_HAPPINESS(who)
    if who == "pet" then
        local happ = GetPetHappiness()
        local health = UnitHealth(who)
        updatePetIcon(health, happ)
    end
end

function DHUD2:UNIT_PET(who)
    if who == "player" then
        hasPet = UnitExists("pet")
        if hasPet and self.db.profile.show.pet then
            petMaxH, petCurH, petCurHFrac, petNeedH = getHealth("pet")
            petMaxP, petCurP, petCurPFrac, petNeedP = getPower("pet", UnitPowerType("pet"))
            updateBar("petHealth", petMaxH, petCurH, petCurHFrac)
            updateBar("petPower", petMaxP, petCurP, petCurPFrac)
            updatePetIcon(petCurH, happ)
            petBorder = getPetBorder(petMaxH, petMaxP)            
        else
            updatePetIcon(0, false)
            petBorder = getPetBorder(0, 0)
        end
        showFrames("pet", hasPet)
    end
    updateAlpha()
end

function DHUD2:PLAYER_TARGET_CHANGED()
    local targetMaxH, targetCurH, targetCurHFrac, targetMaxP, targetCurP, targetCurPFrac
    local p = self.db.profile
    if UnitExists("target") and p.show.target and not(unitIsNPC("target") and not p.show.npc) then
        hasTarget = true
        targetMaxH, targetCurH, targetCurHFrac, targetNeedH = getHealth("target")
        targetMaxP, targetCurP, targetCurPFrac, targetNeedP = getPower("target", UnitPowerType("target"))
        targetBorder = getTargetBorder(targetMaxH, targetMaxP)
        updateBar("targetHealth", targetMaxH, targetCurH, targetCurHFrac)
        updateBar("targetPower", targetMaxP, targetCurP, targetCurPFrac)
        updateCombos()
    else
        hasTarget = false
        targetBorder = getTargetBorder(0, 0)      
    end
    updateTargetIcon(hasTarget)
    updatePlayerAuras()
    updateTargetAuras(hasTarget)
    updateText(hasTarget, "target")
    showFrames("target", hasTarget)
    if UnitExists("targetTarget") and p.show.targetTarget then
        updateText(true, "targetTarget")
        showFrames("targetTarget", true)
    else
        updateText(false, "targetTarget")
        showFrames("targetTarget", false)
    end
    updateAlpha()
end

function DHUD2:PLAYER_REGEN_ENABLED()
    regen = true
    inCombat = false
    getglobal("DHUD2_playerInCombat"):Hide()
    updateAlpha()
end

function DHUD2:PLAYER_REGEN_DISABLED()
    regen = false
    inCombat = true
    if self.db.profile.show.combaticon then
        getglobal("DHUD2_playerInCombat"):Show()
    end
    updateAlpha()
end  

function DHUD2:PLAYER_AURAS_CHANGED()
    updatePlayerAuras()
    updateAlpha()
end

function DHUD2_playerDropDown_Init()
    UnitPopup_ShowMenu( DHUD2_playerDropDownMenu, "SELF", "player" );
end

function DHUD2_targetDropDown_Init()
    local menu = nil
    if (UnitIsEnemy("target", "player")) then
        return
    end
    if (UnitIsUnit("target", "player")) then
        menu = "SELF"
    elseif (UnitIsUnit("target", "pet")) then
        menu = "PET"
    elseif (UnitIsPlayer("target")) then
        if (UnitInParty("target")) then
            menu = "PARTY"
        else
            menu = "PLAYER"
        end
    end
    if menu then
        UnitPopup_ShowMenu( DHUD2_targetDropDownMenu, menu, "target" );
    end
end

function DHUD2:PLAYER_COMBO_POINTS()
    updateCombos()
end

function DHUD2:PLAYER_ALIVE()
    if UnitIsDeadOrGhost("player") then
        self:PLAYER_DEAD()
    else
        self:OnPlayerLife()
    end
end

function DHUD2:OnPlayerLife()
   isAlive = true
   isDead = false
   updateAlpha()
end

function DHUD2:PLAYER_DEAD()
    inCombat = false
    isDead = true
    isAlive = false
    playerNeedH = false
    playerNeedP = false
    petNeedH = false
    petNeedP = false
    isCasting = false
    updateAlpha()
end  

function DHUD2:PLAYER_UPDATE_RESTING()
    if IsResting() and self.db.profile.show.resticon and isAlive then
        getglobal("DHUD2_playerResting"):Show();
    else
        getglobal("DHUD2_playerResting"):Hide();
    end
end  

function DHUD2:RAID_TARGET_UPDATE()
    updateTargetIcon()
end

function DHUD2:PARTY_LOOT_METHOD_CHANGED()
    --self:Debug("PARTY_LOOT_METHOD_CHANGED")
    if GetNumPartyMembers() > 0 and IsPartyLeader()then
        getglobal("DHUD2_playerLeader"):Show()
        local _, master = GetLootMethod()
        if master == 0 then
            getglobal("DHUD2_playerLooter"):Show()
        else
            getglobal("DHUD2_playerLooter"):Hide()
        end
    else
        getglobal("DHUD2_playerLeader"):Hide()
        getglobal("DHUD2_playerLooter"):Hide()
    end
    
end

local flashCastBar, fadeoutCastBar
do
    function flashCastBar()
        local alpha = DHUD2_flash:GetAlpha() + CASTING_BAR_FLASH_STEP
        DHUD2_flash:SetAlpha(alpha)
        DHUD2_flash:Show()
        barFlash = true
        fadeAlpha = 0
        DHUD2_flash:SetScript("OnUpdate", self.OnUpdateFlash)
    end
    
    function fadeoutCastBar()
        --local alpha = DHUD2_flash:GetAlpha() + CASTING_BAR_FLASH_STEP
        --DHUD2_flash:SetAlpha(alpha)
        --DHUD2_flash:Show()
        barFadeOut = true
        fadeAlpha = 1
        --DHUD2_flash:SetScript("OnUpdate", self.OnUpdateFlash)
    end
end

function DHUD2:UNIT_SPELLCAST_START(who)
    local p = self.db.profile
    if p.show.casting and who == "player" then        
        local _, _, _, _, startTime, endTime = UnitCastingInfo(who)
        --this.startTime  = startTime / 1000
        finishTime = endTime / 1000
        spellDuration = (endTime - startTime)/1000
        delayTime = 0
        isCasting = true
        isChanneling = false
        DHUD2_casting:Show()
        DHUD2_flash:Hide()
        updateCastText(spellDuration)
        DHUD2_castTime_Text:Show()
        updateAlpha()
        castTimer = 0
        DHUD2_casting:SetScript("OnUpdate", self.OnUpdateCast)
    end
end

function DHUD2:UNIT_SPELLCAST_CHANNEL_START(who)
        -- elseif (event == "UNIT_SPELLCAST_CHANNEL_START") and (who == "player") then
    if self.db.profile.casting and who == "player" then
        local _, _, _, _, startTime, endTime = UnitCastingInfo(who)
        --this.startTime  = startTime / 1000;
        finishTime = endTime / 1000;
        spellDuration   = (endTime - startTime) / 1000
        isCasting = false
        isChanneling = true
        delayTime = 0
        setBarHeight("casting", 1)
        DHUD2_casting_Texture:SetVertexColor(self:colorize("channelBar",0))        
        DHUD2_casting:Show()
        DHUD2_flash:Hide()
        updateCastText(spellDuration)
        DHUD2_castTime_Text:Show()
        updateAlpha()
        castTimer = 0
        DHUD2_casting:SetScript("OnUpdate", self.OnUpdateCast)
    end
end

function DHUD2:UNIT_SPELLCAST_STOP(who)
    local p = self.db.profile
    if p.show.casting and who == "player" then
        --DHUD2_casting:SetScript("OnUpdate", nil)
        if isCasting then
            isCasting = false
            isChanneling = false
            flashCastBar()
            fadeoutCastBar()
            DHUD2_casting_Texture:SetVertexColor(0, 1, 0)
            setBarHeight("casting", 1)
            updateCastText(0)
            DHUD2_castTime_Text:Hide()
            DHUD2_castDelay_Text:Hide()
        end
    end
end

function DHUD2:UNIT_SPELLCAST_CHANNEL_STOP(who)
    local p = self.db.profile
    if self.db.profile.casting and who == "player" then
        isCasting = false
        isChanneling = false
        fadeoutCastBar()
        setBarHeight("casting", 0)
        updateCastText(0)
        DHUD2_castTime_Text:Hide()
        DHUD2_castDelay_Text:Hide()
    end
end

function DHUD2:OnSpellFail(who)        
    if self.db.profile.casting and who == "player" then
        if not barFadeOut then
            DHUD2_casting:SetScript("OnUpdate", nil)
            DHUD2_casting_Texture:SetVertexColor(1, 0, 0);
            self:setBarHeight("casting",1);
            isCasting = false
            isChanneling = false
            fadeoutCastBar()
            updateCastText(0)
            DHUD2_castTime_Text:Hide()
            DHUD2_castDelay_Text:Hide()          
        end        
    end
end
    
function DHUD2:UNIT_SPELLCAST_DELAYED(who)
    if self.db.profile.casting and who == "player" then
        if(DHUD2_casting:IsShown()) then
            self:Debug("UNIT_SPELLCAST_DELAYED")
            local _, _, _, _, startTime, endTime = UnitCastingInfo(who)
            local delay = endTime / 1000 - finishTime
            --this.startTime = this.startTime + delay;
            finishTime = endTime
            delayTime = delayTime + delay
            --local time = GetTime();
            --if (time > this.endTime) then
            --    time = this.endTime
            --end
        end		
    end
end
   
function DHUD2:UNIT_SPELLCAST_CHANNEL_UPDATE(who)
        -- elseif (event == "UNIT_SPELLCAST_CHANNEL_UPDATE") and (who == "player") then
    if self.db.profile.casting and who == "player" then
        if (DHUD2_casting:IsShown()) then
            local _, _, _, _, startTime, endTime = UnitCastingInfo(who)
            self:Debug ("CHANNEL_UPDATE")
            --local origDuration = this.endTime - this.startTime
            --local elapsedTime = GetTime() - this.startTime;
--                delayTime = (origDuration - elapsedTime) - (who/1000);
--                this.endTime = GetTime() + (who / 1000);
            -- hack
            --if endTime == nil then
            --    endTime = 0;
            --end
            --local delay = endTime / 1000 - finishTime
            --delayTime = (endTime / 1000) - (spellDuration - startTime)
            --spellDuration = spellDuration + delayTime
        end
   end
end

function DHUD2:UNIT_DISPLAYPOWER(who)
    if not(who == "player") or hasPet then
        return
    elseif isDruid then
        if UnitPowerType("player") == 0 then
            petBorder = getPetBorder(0, 0)  
            getglobal("DHUD2_petPower"):Hide()
            self:UnregisterEvent("SmartyCat_ManaUpdated")
        else
            petBorder = getPetBorder(0, 1)  
            getglobal("DHUD2_petPower"):Show()
            self:RegisterEvent("SmartyCat_ManaUpdated", "OnFormUpdateMana")
            local curval, maxval = SmartyCat.GetCurrMana(), SmartyCat.GetMaxMana()
            updateBar("petPower", maxval, curval, curval/maxval)
            updateAlpha()
        end
    end
    local playerMaxP, playerCurP, playerCurPFrac = getPower("player", UnitPowerType("player"))
    updateBar("playerPower", playerMaxP, playerCurP, playerCurPFrac)
end


function DHUD2:OnFormUpdateMana(curmana, maxmana)
    local p = self.db.profile
    if hasPet then
        return
    end
    updateBar("petPower", maxmana, curmana, curmana/maxmana)
    updateAlpha()
end

--"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""







-- Transform Frames
function DHUD2:transformFrames(layout)
    if layout == "DHUD2_Standard_Layout" or layout == "DHUD2_PlayerLeft_Layout" then
        self:SetConfig( "layouttyp", layout );
        self:setLayout();
    
        self.frame_level = 0;
        for i = 1, getn(self.C_names) do
            self:transform(self.C_names[i]);
        end
        
        self:init();
    end
end

-- Frame transformer
function DHUD2:transform(name)
    
    -- does frame exist in list?
    if not self.C_frames[name] then
        return;
    end
    
    -- get frame settings
    local typ, point, frame, relative, x, y, width, height = unpack( self.C_frames[name] );  
    self.frame_level = self.frame_level + 1;
    
    -- debug
    self:Printd("DHUD2: transformFrame "..name.." typ:"..typ .." level:"..self.frame_level);
    
    if typ == "Frame" then
        local ref = getglobal(name);
        ref:SetPoint(point, frame , relative, x, y);
        ref:SetHeight(height);
        ref:SetWidth(width); 
        
        -- debug background
        if self.debug then
            --ref:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }});
            --ref:SetBackdropColor(0,0,0,0.2);
        end
        
        ref:SetFrameLevel(self.frame_level);
        ref:SetParent(frame);
        ref:EnableMouse(false);
        ref:Show();       
    elseif typ == "Texture" then    
        local texture,x0,x1,y0,y1 = unpack( C_textures[name] );
        local ref = getglobal(name);
        ref:ClearAllPoints();
        ref:SetPoint(point, frame , relative, x, y);
        ref:SetHeight(height);
        ref:SetWidth(width);
        
        -- debug background
        if self.debug then
            --ref:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }});
            --ref:SetBackdropColor(0,1,0,0.3);
        end
        strata = "BACKGROUND";
        if name == "DHUD2_casting" or name == "DHUD2_Flash_Bar" then
            strata = "LOW";
        end

        local bgt = getglobal(name.."_Texture");
        bgt:SetTexture(texture);
        bgt:ClearAllPoints();
        bgt:SetPoint("TOPLEFT", ref , "TOPLEFT", 0, 0);
        bgt:SetPoint("BOTTOMRIGHT", ref , "BOTTOMRIGHT", 0, 0);
        bgt:SetTexCoord(x0,x1,y0,y1);
        
        ref:SetFrameStrata(strata);
        ref:SetFrameLevel(self.frame_level);
        ref:SetParent(frame);
        ref:EnableMouse(false);
        ref:Show();

    elseif typ == "Bar" then    
        local texture,x0,x1,y0,y1 = unpack( C_textures[name] );
        local ref = getglobal(name);
        ref:ClearAllPoints();
        ref:SetPoint(point, frame , relative, x, y);
        ref:SetHeight(height);
        ref:SetWidth(width);
        
        -- debug background
        if self.debug then
            --ref:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }});
            --ref:SetBackdropColor(0,1,0,0.1);
        end
        local bgt = getglobal(name.."_Texture");
        bgt:SetTexture(texture);
        bgt:SetPoint(point, ref, relative, 0, 0);
        bgt:SetHeight(height);
        bgt:SetWidth(width);
        bgt:SetTexCoord(x0,x1,y0,y1);
        
        ref:SetFrameStrata("BACKGROUND");
        ref:SetFrameLevel(self.frame_level);
        ref:SetParent(frame);
        ref:EnableMouse(false);
        ref:Show();    
        
    elseif typ == "Text" then
        local ref = getglobal(name);
        ref:ClearAllPoints();
        ref:SetPoint(point, frame , relative, x, y);
        
        -- debug background
        if self.debug then
           -- ref:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }});
            --ref:SetBackdropColor(0,0,1,0.5);
        end
        
        local font = getglobal(name.."_Text");
        font:SetFontObject(GameFontHighlightSmall);
        if self.debug then
            font:SetText(name);
        else
            font:SetText(" ");
        end
        font:SetJustifyH("CENTER");
        font:SetWidth(font:GetStringWidth());
        font:SetHeight(height);
        font:Show();
        font:ClearAllPoints();
        font:SetPoint(point, ref, relative,0, 0);
        
        -- ref:SetFrameStrata("BACKGROUND");
        ref:SetFrameLevel(self.frame_level);
        ref:SetHeight(height);
        ref:SetWidth(font:GetStringWidth());
        ref:SetParent(frame);
        ref:EnableMouse(false);
        ref:Show();
        self:initTextfield(ref,name);         
        		
    -- set buffs    
    elseif typ == "Buff" then
        ref = getglobal(name);
        ref:ClearAllPoints();
        ref:SetPoint(point, frame , relative, x, y);
        ref:SetHeight(height);
        ref:SetWidth(width);
        
        -- debug background
        if self.debug then
           -- ref:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }});
           -- ref:SetBackdropColor(1,0,0,0.2);
        end

        local font = getglobal(name.."_Text");
        font:SetFontObject(GameFontHighlightSmall);
        font:SetText("");
        font:SetJustifyH("RIGHT");
        font:SetJustifyV("BOTTOM");
        font:SetWidth(width+1);
        font:SetHeight(height-5);
        font:SetFont( defaultfont, width / 2.2, "OUTLINE");
        font:Show();
        font:ClearAllPoints();
        font:SetPoint(point, frame, relative,x, y);
        
        local bgt = getglobal(name.."_Border");
        bgt:SetTexture("Interface\\Buttons\\UI-Debuff-Border");
        bgt:SetPoint("BOTTOM", ref, "BOTTOM", 0, 0);
        bgt:SetHeight(height);
        bgt:SetWidth(width);
        bgt:SetTexCoord(0,1,0,1);  
                
        ref:SetNormalTexture( "Interface\\Icons\\Ability_Druid_TravelForm" );
        ref:SetFrameLevel(self.frame_level);
        ref:SetParent(frame);
        
        ref:SetScript("OnEnter", function() 
                if (not this:IsVisible()) then return; end
                if self.db.profile.show.auratips == 0 then return; end
                GameTooltip:SetOwner(this, "ANCHOR_BOTTOMRIGHT");
                if this.hasdebuff == 1 then
                    GameTooltip:SetUnitDebuff(this.unit, this.id);
                else
                    GameTooltip:SetUnitBuff(this.unit, this.id);
                end
            end );
 
         ref:SetScript("OnLeave", function() 
                GameTooltip:Hide();
            end );
                         
        ref:EnableMouse(true);
        ref:Show();
        
    elseif typ == "PlayerBuff" then
        ref = getglobal(name);
        ref:ClearAllPoints();
        ref:SetPoint(point, frame , relative, x, y);
        ref:SetHeight(height);
        ref:SetWidth(width);
        
        local font = getglobal(name.."_Text");
        font:ClearAllPoints();
        font:SetFontObject(GameFontHighlightSmall);
        font:SetPoint("CENTER", ref, "CENTER", 0,0);
        font:SetText("");
        font:SetJustifyH("CENTER");
        font:SetJustifyV("CENTER");
        font:SetWidth(width*2);
        font:SetHeight(height);
        
        local bgt = getglobal(name.."_Border");
        bgt:SetTexture("Interface\\AddOns\\DHUD2\\Layouts\\serenity0");
        bgt:SetVertexColor(1.0,1.0,1.0);
        bgt:SetPoint("TOPLEFT", ref, "TOPLEFT", -7.5, 7.5);
        bgt:SetHeight(height*1.6);
        bgt:SetWidth(width*1.6);
        bgt:SetTexCoord(0,1,0,1);
        bgt:SetBlendMode("BLEND");
                
        ref:SetNormalTexture( "Interface\\Icons\\Ability_Druid_TravelForm" );
        ref:SetFrameLevel(self.frame_level);
        ref:SetParent(frame);
        
        ref:SetScript("OnEnter", function() 
                if (not this:IsVisible()) then return; end
                if p.show.auratips == 0 then return; end
                GameTooltip:SetOwner(this, "ANCHOR_BOTTOMRIGHT");
                GameTooltip:SetPlayerBuff(this.id);
            end );
 
         ref:SetScript("OnLeave", function() 
                GameTooltip:Hide();
            end );
                         
        ref:EnableMouse(true);
        ref:Show();
        
    end
end    
    

-- Reset settings
function DHUD2:reset()
    for k, v in pairs(config) do
        self.db.profile[k] = config[k];
    end
    self:init();
    self:Print("Default Settings Loaded.")
end

-- set config value
function DHUD2:SetConfig(key, value)
   if (self.db.profile.p.key ~= value) then
      self.db.profile.p.key = value;
   end
end

-- get config value
function DHUD2:GetConfig(key)
    return self.db.profile.p.key or nil;
end

-- toggle config value
function DHUD2:ToggleConfig(key)
    local output   = "/DHUD2 %s";
    local response = "|cff6666cc%s|r is now %s";
    if self.db.profile.p.key == nil then
        self.db.profile.p.key = 0;
    end
    
    if self.db.profile.p.key == 1 then
        self.db.profile.p.key = 0;
        self:Print(string_format(
            response,
            key,
            "|cffff0000OFF|r"
        ));                                                   
    else
        self.db.profile.p.key = 1;
        self:Print(string_format(
            response,
            key,
            "|cff00ff00ON|r"
        ));  
    end
    
    self:init();
end

-- range command
function DHUD2:CommandRange(command,rest)
    local num = tonumber(rest);
    local output   = "/DHUD2 |cff6666cc%s|r |cffcccccc%s - %s|r";
    local response = "|cff6666cc%s|r set to: |cff00ff00%s|r |cffcccccc[%s - %s]|r";
    -- print error
    if num == nil then
        self:Print(string_format(
            output,
            command,
            DHUD2_CommandList[command]["minvalue"],
            DHUD2_CommandList[command]["maxvalue"]
        )); 
        return;
    end
    
    -- in range
    if num >= DHUD2_CommandList[command]["minvalue"] and num <= DHUD2_CommandList[command]["maxvalue"] then
        DHUD2:SetConfig(command,num);
        self:init();
        self:Print(string_format(
            response,
            command,
            num,
            DHUD2_CommandList[command]["minvalue"],
            DHUD2_CommandList[command]["maxvalue"]
        )); 
        return;
    -- out of range
    else    
        self:Print(string_format(
            output,
            command,
            DHUD2_CommandList[command]["minvalue"],
            DHUD2_CommandList[command]["maxvalue"]
        )); 
        return;
    end
    
end

-- set color
function DHUD2:SetColor(key, value)
    local output   = "/DHUD2 |cff6666cc%s|r 000000 - FFFFFF";
    local response = "|cff6666cc%s|r set to: |cff%s%s|r";
    if (self.db.profile.p.key ~= value) then
        self.db.profile.p.key = value;
        self:Print( string_format(
            response, key, value , value
        ) ); 
    end
end

    -- Combat / Regen / Attack check
function DHUD2:PLAYER_ENTER_COMBAT()
    attacking = true;
    inCombat  = true;
    self:updateAlpha()
end

function DHUD2:PLAYER_LEAVE_COMBAT()
    attacking = nil;
    if regen then
        inCombat = nil
    end
    self:updateAlpha()
end

    -- movable farme
local moveFrame = {
    mainFrame = {
        "xoffset",
        "yoffset",
    },
    leftFrame = {
        "hudspacing",
        "",
        "-",
    },
    rightFrame = {
        "hudspacing",
        "",
    },
    target = {
        "",
        "targettexty",
    },
    targetTarget = {
        "targetTargettextx",
        "targetTargettexty",
    },
    playerHealth = {
        "playerhptextx",
        "playerhptexty",
    },
    playerPower = {
        "playerPowertextx",
        "playerPowertexty",
    },
    targetHealth = {
        "targethptextx",
        "targethptexty",
    },
    targetPower = {
        "targetPowertextx",
        "targetPowertexty",
    },
    petHealth = {
        "pethptextx",
        "pethptexty",
    },
    petPower = {
        "petPowertextx",
        "petPowertexty",
    }, 
    castTime = {
        "casttextx",
        "casttexty",
    },
    castDelay = {
        "delaytextx",
        "delaytexty",
    },
}

local outline = {
    "",
    "OUTLINE",
    "THICKOUTLINE",
}


